/*********************************************
 * Tululoo Game Maker v1.3.0
 *
 * Creators 
 * Zoltan Percsich
 * Vadim "YellowAfterlife" Dyachenko
 *
 * (c) SilentWorks 2011 - 2013
 * All rights reserved.
 * www.tululoo.com
 *
 * Contributors:
 * Csaba Herbut
 ********************************************/

function tu_detect_audio(_type) {
	var _au = document.createElement('audio');
	return _au.canPlayType && _au.canPlayType(_type).replace(/no/, '');
}
//
var	__path__ = window.__path__ ? window.__path__ : '',
	// system variables:
	tu_gameloop = tu_canvas = tu_context = tu_room_to_go = null, tu_canvas_id = 'tululoocanvas',
	tu_canvas_css = 'background: rgb(42, 42, 42); border: 0;',
	tu_loading = tu_load_total = 0,
	var_override_ = (Object.defineProperty != undefined),
	// resources:
	tu_sprites = [], tu_audios = [], tu_backgrounds = [], tu_fonts = [], tu_scenes = [],
	// time:
	tu_frame_time = tu_frame_step = tu_frame_el = tu_frame_count = tu_elapsed = 0,
	tu_prev_cycle_time = tu_prev_frame_time = (new Date()).getTime(),
	// math:
	max = Math.max, min = Math.min, round = Math.round, floor = Math.floor, ceil = Math.ceil,
	sin = Math.sin, cos = Math.cos, sqrt = Math.sqrt, tan = Math.tan, rand = Math.random,
	arccos = Math.acos, arcsin = Math.asin, arctan = Math.atan, arctan2 = Math.atan2,
	tu_r2d = -180 / Math.PI, tu_d2r = Math.PI / -180, tu_2pi = Math.PI * 2,
	// i/o variables:
	mouse_x = mouse_y = 0, mouse_down = mouse_pressed = mouse_released = false,
	key_down = [], key_pressed = [], key_released = [], tu_vkeys = [],
	tu_keys_pressed = [], tu_keys_released = [],
	touch_x = [], touch_y = [], touch_count = 0,
	tu_unpausekey = 27, tu_paused = false, tu_modal = null, tu_modaldraw = true,
	// i/o constants:
	vk_0 = 48, vk_1 = 49, vk_2 = 50, vk_3 = 51, vk_4 = 52, vk_5 = 53, vk_6 = 54,
	vk_7 = 55, vk_8 = 56, vk_9 = 57, vk_a = 65, vk_add = 107, vk_alt = 18, vk_b = 66,
	vk_backspace = 8, vk_c = 67, vk_ctrl = 17, vk_d = 68, vk_decimal = 110, vk_delete = 46,
	vk_divide = 111, vk_down = 40, vk_e = 69, vk_end = 35, vk_enter = 13, vk_escape = 27,
	vk_f1 = 112, vk_f2 = 113, vk_f3 = 114, vk_f4 = 115, vk_f5 = 116, vk_f6 = 117,
	vk_f7 = 118, vk_f8 = 119, vk_f9 = 120, vk_f10 = 121, vk_f11 = 122, vk_f12 = 123,
	vk_g = 71, vk_h = 72, vk_home = 36, vk_f = 70, vk_i = 73, vk_insert = 45, vk_j = 74, vk_k = 75,
	vk_l = 76, vk_left = 37, vk_m = 77, vk_multiply = 106, vk_n = 78, vk_num0 = 96, vk_num1 = 97,
	vk_num2 = 98, vk_num3 = 99, vk_num4 = 100, vk_num5 = 101, vk_num6 = 102, vk_num7 = 103,
	vk_num8 = 104, vk_num9 = 105, vk_o = 79, vk_p = 80, vk_pagedown = 34, vk_pageup = 33,
	vk_pause = 19, vk_q = 81, vk_r = 82, vk_right = 39, vk_s = 83, vk_shift = 16, vk_space = 32,
	vk_subtract = 109, vk_t = 84, vk_tab = 9, vk_u = 85, vk_up = 38, vk_v = 86, vk_w = 87,
	vk_x = 88, vk_y = 89, vk_z = 90,
	// collisions:
	ct_null = 0, ct_point = 1, ct_box = 2, ct_circle = 3,
	// tiles:
	tu_tiles = [], tu_tilesi = [], tu_tilez = 256,
	// sound variables:
	tu_wav_supported = tu_detect_audio('audio/wav; codecs="1"'),
	tu_ogg_supported = tu_detect_audio('audio/ogg; codecs="vorbis"'),
	tu_mp3_supported = tu_detect_audio('audio/mpeg;'),
	// drawing:
	tu_draw_alpha = 1, tu_draw_color_red = tu_draw_color_green = tu_draw_color_blue = 0,
	tu_draw_font = "Arial 12px", tu_draw_halign = "left", tu_draw_valign = "top",
	tu_draw_font_ = { size: 12, family: 'Arial', bold: false, italic: false },
	tu_draw_color = "rgb(" + tu_draw_color_red + "," + 
	tu_draw_color_green + "," + tu_draw_color_blue + ")", 
	tu_redraw, tu_redraw_auto = true,
	tu_viewport_inst = null,
	// drawing constants:
	fa_left = "left", fa_center = "center", fa_right = "right",
	fa_top = "top", fa_middle = "middle", fa_bottom = "bottom",
	// system room variables:
	tu_depth = [], tu_depthi = [], tu_depthu = [], tu_types = [], tu_persist = [],
	// public room variables:
	room_current = null,
	room_speed = 30, fps = room_speed,
	room_background = null,
	room_width = 0, room_height = 0,
	room_background_color_show = true, room_background_color_red = 0, 
	room_background_color_green = 0, room_background_color_blue = 0,
	room_viewport_width = 0, room_viewport_height = 0,
	room_viewport_object = null,
	room_viewport_hborder = 0, room_viewport_vborder = 0,
	room_viewport_x = 0, room_viewport_y = 0,
	global = null;
// keyboard functions:
function keyboard_check(_key) { return key_down[_key]; }
function keyboard_check_pressed(_key) { return key_pressed[_key]; }
function keyboard_check_released(_key) { return key_released[_key]; }
// mouse functions:
function mouse_check() { return mouse_down; }
function mouse_check_pressed() { return mouse_pressed; }
function mouse_check_released() { return mouse_released; }
// virtual keys:
function vkey() {
	this.top = 0;
	this.left = 0;
	this.right = 0;
	this.bottom = 0;
	this.key = 0;
	this.down = false;
	this.active = true;
}
function vkey_add(_x, _y, _w, _h, _k) {
	var _v = new vkey();
	_v.left = _x;
	_v.top = _y;
	_v.right = _x + _w;
	_v.bottom = _y + _h;
	_v.width = _w;
	_v.height = _h;
	_v.key = _k;
	tu_vkeys.push(_v);
	return _v;
}
// misc:
function trace() { console.log.apply(console, arguments); }
function tu_idle() { } // left empty on purpose
// minimal math:
function abs(_value) { return _value < 0 ? -_value : _value; }
function sign(_value) { return _value > 0 ? 1 : _value < 0 ? -1 : 0; }
function choose() { return arguments[~~(Math.random() * arguments.length)]; }
function random(_value) { return Math.random() * _value; }
function irandom(_value) { return ~~(Math.random() * _value + 1); }
// trig functions:
function lengthdir_x(_length, _direction) { return _length * Math.cos(_direction * tu_d2r); }
function lengthdir_y(_length, _direction) { return _length * Math.sin(_direction * tu_d2r); }
function point_distance(_x1, _y1, _x2, _y2) { return Math.sqrt(Math.pow(( _x1 - _x2), 2) + Math.pow((_y1 - _y2), 2)); }
function point_direction(_x1, _y1, _x2, _y2) { return Math.atan2(_y2 - _y1, _x2 - _x1) * tu_r2d; }
function degtorad(_degree) { return _degree * tu_d2r; }
function radtodeg(_degree) { return _degree * tu_r2d; }
// sound functions:
function sound_mode(_sound, _mode) {
	if (_sound.audio.networkState == _sound.audio.NETWORK_NO_SOURCE) return;
	switch (_sound.type) {
	case "wav": if (!tu_wav_supported) return; break;
	case "ogg": if (!tu_ogg_supported) return; break;
	case "mp3": if (!tu_mp3_supported) return; break;
	}
	if (_mode != 3) {
		_sound.audio.pause();
		if (_mode != 0) {
			_sound.audio.currentTime = 0;
		} else return;
		_sound.audio.loop = _mode > 1;
	}
	_sound.audio.play();
}
function sound_play(_sound) { sound_mode(_sound, 1); }
function sound_loop(_sound) { sound_mode(_sound, 2); }
function sound_resume(_sound) { sound_mode(_sound, 3); }
function sound_stop(_sound) { sound_mode(_sound, 0); }
function sound_stop_all() { for ( var _s = 0; _s < tu_audios.length; _s++) sound_stop( tu_audios[_s] ); }
function sound_volume( _sound, _volume) {
	if (_sound.audio.networkState == _sound.audio.NETWORK_NO_SOURCE) return;
	_sound.audio.volume = _volume;
}
// draw sprite:
function draw_sprite(_sprite_index, _sub_image, _x, _y) {
	if (_sprite_index == null) return;
	if (_sub_image > _sprite_index.frames.length - 1) _sub_image = 0;
	tu_context.save();
	tu_context.translate(_x - room_viewport_x, _y - room_viewport_y);
	tu_context.globalAlpha = tu_draw_alpha;
	tu_context.drawImage(_sprite_index.frames[~~_sub_image], -_sprite_index.xoffset, -_sprite_index.yoffset);
	tu_context.restore();
}
function draw_sprite_part(_sprite_index, _sub_image, _left, _top, _width, _height, _x, _y) {
	if (_sprite_index == null) return;
	if (_sub_image >= _sprite_index.frames.length) _sub_image = _sub_image % _sprite_index.frames.length;
	tu_context.save();
	tu_context.translate(_x - room_viewport_x, _y - room_viewport_y);
	tu_context.globalAlpha = tu_draw_alpha;
	tu_context.drawImage(_sprite_index.frames[~~_sub_image], _left, _top, _width, _height, 0, 0, _width, _height);
	tu_context.restore();
}
function draw_sprite_ext(_sprite_index, _sub_image, _x, _y, _xscale, _yscale, _rotation, _alpha) {
	if (_sprite_index == null) return;
	if (_sub_image >= _sprite_index.frames.length) _sub_image = _sub_image % _sprite_index.frames.length;
	tu_context.save();
	tu_context.translate(_x - room_viewport_x, _y - room_viewport_y);
	tu_context.rotate(degtorad(_rotation));
	tu_context.scale(_xscale, _yscale);
	tu_context.globalAlpha = _alpha;
	tu_context.drawImage(_sprite_index.frames[~~_sub_image], -_sprite_index.xoffset , -_sprite_index.yoffset, _sprite_index.width, _sprite_index.height);
	tu_context.restore();
}
// draw text:
function draw_text(_x, _y, _text) {
	tu_context.font = tu_draw_font;
	tu_context.textAlign = tu_draw_halign;
	tu_context.textBaseline = tu_draw_valign;
	tu_context.fillStyle = tu_context.strokeStyle = "rgba(" + tu_draw_color + ", " + tu_draw_alpha + ")";
	tu_context.fillText( _text, _x - room_viewport_x, _y - room_viewport_y );
}
// draw shapes:
function draw_rectangle(_x1, _y1, _x2, _y2, _outline) {
	tu_context.fillStyle = tu_context.strokeStyle = "rgba(" + tu_draw_color + ", " + tu_draw_alpha + ")";
	tu_context.beginPath();
	if (_outline) tu_context.strokeRect( _x1- room_viewport_x, _y1 - room_viewport_y, _x2 - _x1, _y2 - _y1 );
	else tu_context.fillRect( _x1- room_viewport_x, _y1 - room_viewport_y, _x2 - _x1, _y2 - _y1 );
	tu_context.closePath();
}
function draw_circle(_x, _y, _r, _outline) {
	tu_context.fillStyle = tu_context.strokeStyle = "rgba(" + tu_draw_color + ", " + tu_draw_alpha + ")";
	tu_context.beginPath();
	tu_context.arc( _x - room_viewport_x, _y - room_viewport_y, _r, 0, tu_2pi, true );
	tu_context.closePath();
	!_outline ? tu_context.fill() : tu_context.stroke();
}

function draw_line(_x1, _y1, _x2, _y2) {
	tu_context.strokeStyle = "rgba(" + tu_draw_color + ", " + tu_draw_alpha + ")";
	tu_context.beginPath();
	tu_context.moveTo( _x1 - room_viewport_x, _y1 - room_viewport_y );
	tu_context.lineTo( _x2 - room_viewport_x, _y2 - room_viewport_y );
	tu_context.closePath();
	tu_context.stroke();	
}
// draw settings:
function draw_set_alpha(_alpha) {
	tu_draw_alpha = _alpha;
}
function draw_set_color( _r, _g, _b) {
	tu_draw_color_red = _r;
	tu_draw_color_green = _g;
	tu_draw_color_blue = _b;
	tu_draw_color = tu_draw_color_red + "," + tu_draw_color_green + "," + tu_draw_color_blue;
	tu_context.fillStyle = "rgba(" + tu_draw_color + ", " + tu_draw_alpha + ")";
	tu_context.strokeStyle = "rgb(" + tu_draw_color + ")";
}
function draw_set_linewidth(_width) { tu_context.lineWidth = _width; }
// draw settings - font:
function draw_set_font (_font) {
	tu_draw_font_ = _font;
	tu_draw_font = (_font.bold == 1 ? "bold" : "") + " " + (_font.italic == 1 ? "italic" : "") + " " + _font.size + "px " + _font.family;
	tu_context.font = tu_draw_font;
	tu_context.textAlign = tu_draw_halign;
	tu_context.textBaseline = tu_draw_valign;
}
function draw_set_halign(_halign) { tu_draw_halign = _halign; }
function draw_set_valign(_valign) { tu_draw_valign = _valign; }
// room translations:
function room_goto(_scene) {
	tu_viewport_inst = null;
	tu_room_to_go = _scene;
}
function room_goto_next() {
	var _ri = 0, _r;
	for (_r = 0; _r < tu_scenes.length; _r++) if (tu_scenes[_r] == room_current) _ri = _r;
	if (typeof tu_scenes[(_ri + 1)] == "object") room_goto(tu_scenes[_ri + 1]);
}
function room_goto_previous() {
	var _ri = 0, _r;
	for (_r = 0; _r < tu_scenes.length; _r++) if (tu_scenes[_r] == room_current) _ri = _r;
	if (typeof tu_scenes[(_ri - 1)] == "object") room_goto(tu_scenes[_ri - 1]);
}
function room_goto_first() { room_goto(tu_scenes[0]); }
function room_goto_last() { room_goto(tu_scenes[(tu_scenes.length - 1)]); }
function room_restart() { room_goto(room_current); }
// instance functions:
function instance_create_(_x, _y, _object) {
	var o = new _object.constructor;
	o.parameters = arguments.length > 3 ? Array.prototype.slice.call(arguments, 3) : [];
	o.object_index = _object;
	o.__instance = true;
	o.xstart = o.x = _x;
	o.ystart = o.y = _y;
	o._depth = o.depthstart;
	instance_activate(o);
	return o;
}
function instance_create(_x, _y, _object) {
	var o = instance_create_.apply(this, arguments);
	o.on_creation();
	return o;
}
function instance_number(_object) {
	return instance_list(_object).length;
}
function instance_first(_object) {
	var l = instance_list(_object);
	return l.length ? l[0] : null;
}
// BBox <> BBox
function collide_bbox_bbox(l1, t1, r1, b1, l2, t2, r2, b2) {
	return !(b1 <= t2 || t1 >= b2 || r1 <= l2 || l1 >= r2);
}
// BBox <> SpriteBox
// (left, top, right, bottom, instX, instY, scaleX, scaleY, sprite, ofsX, ofsY)
function collide_bbox_sbox(l1, t1, r1, b1, x2, y2, h2, v2, s2) {
	return
	!( b1 <= y2 + v2 * (s2.collision_top - s2.yoffset)
	|| t1 >= y2 + v2 * (s2.collision_bottom - s2.yoffset)
	|| r1 <= x2 + h2 * (s2.collision_left - s2.xoffset)
	|| l1 <= x2 + h2 * (s2.collision_right - s2.xoffset));
}
// SpriteBox <> BBox
function collide_sbox_point(x2, y2, h2, v2, s2, x1, y1) {
	return
	!( y1 <= y2 + v2 * (s2.collision_top - s2.yoffset)
	|| y1 >= y2 + v2 * (s2.collision_bottom - s2.yoffset)
	|| x1 <= x2 + h2 * (s2.collision_left - s2.xoffset)
	|| x1 <= x2 + h2 * (s2.collision_right - s2.xoffset));
}
// SpriteBox <> Circle
function collide_sbox_circle(x2, y2, h2, v2, s2, x1, y1, r1) {
	var u, v, dx, dy;
	u = x2 + h2 * (s2.collision_left - s2.xoffset);
	v = x2 + h2 * (s2.collision_right - s2.xoffset);
	dx = (x2 < u ? u : x2 > v ? v : x2) - x2;
	u = y2 + v2 * (s2.collision_top - s2.yoffset);
	v = y2 + v2 * (s2.collision_bottom - s2.yoffset);
	dy = (y2 < u ? u : y2 > v ? v : y2) - y2;
	return (dx * dx + dy * dy < r1 * r1);
}
// BBox <> Point
function collide_bbox_point(l1, t1, r1, b1, x2, y2) {
	return (x2 > l1 && x2 < r1 && y2 > t1 && y2 < b1);
}
// BBox <> Circle
function collide_bbox_circle(l1, t1, r1, b1, x2, y2, r2) {
	var dx = (x2 < l1 ? l1 : x2 > r1 ? r1 : x2) - x2, 
		dy = (y2 < t1 ? t1 : y2 > b1 ? b1 : y2) - y2;
	return (dx * dx + dy * dy < r2 * r2);
}
// Circle <> Range
function collide_circle_range(dx, dy, dr) {
	return (dx * dx + dy * dy < dr * dr);
}
// Circle <> Circle
function collide_circle_circle(x1, y1, r1, x2, y2, r2) {
	return collide_circle_range(x1 - x2, y1 - y2, r1 + r2);
}
// Circle <> Point
function collide_circle_point(x1, y1, r1, x2, y2) {
	return collide_circle_range(x1 - x2, y1 - y2, r1);
}
// instance collision checking:
function instance_position(_px, _py, _object, _mult) {
	var _x, _y, _ox, _oy, _sx, _sy, _o, _s, _i, _il, _r, _dx, _dy,
		_q = (_object.__instance ? [_object] : instance_list(_object)),
		_tm = (_mult) ? true : false;
	if (_tm) _ta = [];
	_il = _q.length;
	for (_i = 0; _i < _il; _i++) {
		_o = _q[_i];
		if (!_o.collision_checking) continue;
		_s = _o.sprite_index;
		if (!_s) continue;
		_x = _o.x; _sx = _o.image_xscale;
		_y = _o.y; _sy = _o.image_yscale;
		switch (_s.collision_shape)
		{
		case 0x2:
			if (_sx == 1 && _sy == 1) {
				_ox = _s.xoffset; _oy = _s.yoffset;
				if (!collide_bbox_point(_x + _s.collision_left - _ox, _y + _s.collision_top - _oy,
				_x + _s.collision_right - _ox, _y + _s.collision_bottom - _oy, _px, _py)) break;
			} else if (!collide_sbox_point(_x, _y, _sx, _sy, _s)) break;
			if (!_tm) return _o;
			_ta.push(_o);
			break;
		case 0x3:
			_r = _s.collision_radius * Math.max(_o.image_xscale, _o.image_yscale);
			_dx = _o.x + (_s.width / 2 - _s.xoffset) - _px;
			_dy = _o.y + (_s.height / 2 - _s.yoffset) - _py;
			if ((_dx * _dx) + (_dy * _dy) > _r * _r) break;
			if (!_tm) return _o;
			_ta.push(_o);
			break;
		}
	}
	return _tm ? _ta : null;
}
//
function __place_meeting__(nx, ny, what, many) {
	this.other = null;
	var i, l,
		// sprite, scale:
		ts = this.sprite_index,
		tsx, tsy, tfx, tfy, tst,
		// circle:
		tcx, tcy, tcr,
		// bbox:
		tbl, tbr, tbt, tbb,
		// instances, multiple, output, types:
		tz, tm, ct, ch, ra,
		// other:
		o, ox, oy, os, ost, osx, osy, ofx, ofy, ofr;
	if (ts == null) return false;
	tfx = ts.xoffset;
	tfy = ts.yoffset;
	tsx = this.image_xscale;
	tsy = this.image_yscale;
	tst = ts.collision_shape;
	// bbox:
	if (tst == 2) {
		tbl = nx + tsx * (ts.collision_left - tfx);
		tbr = nx + tsx * (ts.collision_right - tfx);
		tbt = ny + tsy * (ts.collision_top - tfy);
		tbb = ny + tsy * (ts.collision_bottom - tfy);
	}
	// circle:
	if (tst == 3) {
		tcr = ts.collision_radius * (tsx > tsy ? tsx : tsy);
		tcx = nx + tsx * (ts.width / 2 - tfx);
		tcy = ny + tsy * (ts.height / 2 - tfy);
	}
	//
	tz = (what.__instance ? [what] : instance_list(what));
	tm = many ? true : false;
	if (tm) ra = [];
	l = tz.length;
	for (i = 0; i < l; i++) {
		o = tz[i];
		if (!o.collision_checking) continue;
		os = o.sprite_index;
		if (os == null) continue;
		ox = o.x; osx = o.image_xscale;
		oy = o.y; osy = o.image_yscale;
		ost = os.collision_shape;
		ct = (tst << 4) | ost;
		ch = false;
		switch(ct) {
		case 0x22:
			if (osx == 1 && osy == 1) {
				ofx = os.xoffset; ofy = os.yoffset;
				if (!collide_bbox_bbox(tbl, tbt, tbr, tbb,
				ox + os.collision_left - ofx, oy + os.collision_top - ofy,
				ox + os.collision_right - ofx, oy + os.collision_bottom - ofy)) break;
			} else if (!collide_bbox_sbox(tbl, tbt, tbr, tbb, ox, oy, osx, osy, os)) break;
			ch = true;
			break;
		case 0x23:
			ofr = os.collision_radius * (osx > osy ? osx : osy);
			ofx = ox + osx * (os.width / 2 - os.xoffset);
			ofy = oy + osy * (os.height / 2 - os.yoffset);
			if (!collide_bbox_circle(tbl, tbt, tbr, tbb, ofx, ofy, ofr)) break;
			ch = true;
			break;
		case 0x32:
			if (osx == 1 && osy == 1) {
				ofx = os.xoffset; ofy = os.yoffset;
				if (!collide_bbox_circle(
				ox + os.collision_left - ofx, oy + os.collision_top - ofy,
				ox + os.collision_right - ofx, oy + os.collision_bottom - ofy,
				tcx, tcy, tcr)) break;
			} else if (!collide_sbox_circle(ox, oy, osx, osy, os, tcx, tcy, tcr)) break;
			ch = true;
			break;
		case 0x33:
			ofr = os.collision_radius * (osx > osy ? osx : osy);
			ofx = ox + osx * (os.width / 2 - os.xoffset);
			ofy = oy + osy * (os.height / 2 - os.yoffset);
			if (!collide_circle_circle(tcx, tcy, tcr, ofx, ofy, ofr)) break;
			ch = true;
			break;
		} if (!ch) continue;
		this.other = o;
		o.other = this;
		if (!tm) return (o);
		ra.push(o);
	} return ra;
}
function position_meeting(_x, _y, _object) {
	return instance_position(_x, _y, _object) != null;
}
function __move_towards_point__(_x, _y, _speed) {
	if (_speed == 0) return;
	if (this.x == _x && this.y == _y) return;
	var _dx = _x - this.x,
		_dy = _y - this.y,
		_dist = _dx * _dx + _dy * _dy;
	if (_dist < _speed * _speed) {
		this.x = _x;
		this.y = _y;
	} else {
		_dist = Math.sqrt(_dist);
		this.x += _dx * _speed / _dist;
		this.y += _dy * _speed / _dist;
	}
}

function __instance_destroy__() {
	tu_trash.push( this );
}
// web data:
function save_web_data(_name, _value) { if (window.localStorage) window.localStorage.setItem(_name, _value); }
function save_web_integer(_name, _value) { if (window.localStorage) window.localStorage.setItem("int_" + _name, _value); }
function save_web_float(_name, _value) { if (window.localStorage) window.localStorage.setItem("float_" + _name, _value); }
function save_web_string(_name, _value) { if (window.localStorage) window.localStorage.setItem("string_" + _name, _value); }
function load_web_data(_name) { if (window.localStorage) return window.localStorage.getItem(_name); }
function load_web_integer(_name) { if (window.localStorage) return parseInt(window.localStorage.getItem("int_" + _name)); }
function load_web_float(_name) { if (window.localStorage) return parseFloat(window.localStorage.getItem("float_" + _name)); }
function load_web_string(_name) { if (window.localStorage) return '' + window.localStorage.getItem("string_" + _name); }
function delete_web_data(_name) { if (window.localStorage) window.localStorage.removeItem(_name); }
function delete_web_integer(_name) { if (window.localStorage) window.localStorage.removeItem("int_" + _name); }
function delete_web_float(_name) { if (window.localStorage) window.localStorage.removeItem("float_" + _name); }
function delete_web_string(_name) { if (window.localStorage) window.localStorage.removeItem("string_" + _name); }
function clear_web_data() { if (window.localStorage) window.localStorage.clear(); }
function web_data_number() { if (window.localStorage) return window.localStorage.length; }
// misc functions:
function pause_game( _key) {
	tu_paused = true;
	tu_unpausekey = _key;
}
function modal_end() {
	if (tu_modal == null) return;
	tu_modal.instance_destroy();
	tu_modal = null;
}
function modal_start(_inst, _draw) {
	if (tu_modal != null) modal_end();
	tu_modal = _inst;
	tu_modaldraw = _draw;
}
//
function show_mouse() { tu_canvas.style.cursor = "default"; }
function hide_mouse() { tu_canvas.style.cursor = "none"; }
//
function tu_gettime() { return (new Date()).getTime(); }

/***********************************************************************
 * ENGINE
 ***********************************************************************/
 
function tu_global () { }
global = new tu_global();
//{ Events
function __keydownlistener__(e) {
	var r = true;
	if (!e) e = window.event;
	if (document.activeElement && document.activeElement == tu_canvas || document.activeElement == document.body) r = false;
	if (e.repeat) return;
	var keyCode = window.event ? e.which : e.keyCode;
	if (!key_down[keyCode]) {
		key_pressed[keyCode] = true;
		tu_keys_pressed.push(keyCode);
	}
	key_down[keyCode] = true;
	if (!r) e.preventDefault();
	return r;
};
function __keyuplistener__(e) {
	var r = true;
	if (!e) e = window.event;
	if (document.activeElement && document.activeElement == tu_canvas || document.activeElement == document.body) r = false;
	var keyCode = window.event ? e.which : e.keyCode;
	if (key_down[keyCode])
	{
		key_released[keyCode] = true;
		tu_keys_released.push(keyCode);
	}
	key_down[keyCode] = false;
	if (!r) e.preventDefault();
	return r;
};
function __touchsim__(_x, _y) {
	var r = [{}];
	r[0].pageX = tu_canvas.offsetLeft + _x;
	r[0].pageY = tu_canvas.offsetTop + _y;
	__touchvkey__(r);
}
function __mousemovelistener__(_e) {
	if (_e.pageX != undefined && _e.pageY != undefined) {
		mouse_x = _e.pageX;
		mouse_y = _e.pageY;
	} else {
		mouse_x = _e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
		mouse_y = _e.clientY + document.body.scrollTop + document.documentElement.scrollTop;
	}
	if (room_current != null) {
		mouse_x -= tu_canvas.offsetLeft;
		mouse_y -= tu_canvas.offsetTop;			
	}
	if (mouse_down) __touchsim__(mouse_x, mouse_y);
};
function __mousedownlistener__(_e) {
	//if (!mouse_down) mouse_pressed = true;
	//mouse_down = true;
	__touchsim__(mouse_x, mouse_y);
};
function __mouseuplistener__(_e) {
	//if (mouse_down) mouse_released = true;
	//mouse_down = false;
	__touchvkey__([]);
};
function __touchvkey__(_t) {
	var _tx = 0, _ty = 0, _tc = 0, _tl = _t.length, _vl = tu_vkeys.length, _i, _j, _c, _k,
		_dx = tu_canvas.offsetLeft, _dy = tu_canvas.offsetTop, _mx = _my = 1;
	if (tu_canvas.style.width) _mx 
	touch_x = []; touch_y = []; touch_count = 0;
	for (_i = 0; _i < _vl; _i++) tu_vkeys[_i].count = 0;
	for (_i = 0; _i < _tl; _i++) {
		_c = 0;
		for (_j = 0; _j < _vl; _j++) {
			if (!tu_vkeys[_j].active) continue;
			if (_t[_i].pageX - _dx > tu_vkeys[_j].right) continue;
			if (_t[_i].pageX - _dx < tu_vkeys[_j].left) continue;
			if (_t[_i].pageY - _dy < tu_vkeys[_j].top) continue;
			if (_t[_i].pageY - _dy > tu_vkeys[_j].bottom) continue;
			tu_vkeys[_j].count++;
			if (!tu_vkeys[_j].down) {
				tu_vkeys[_j].down = true;
				_k = tu_vkeys[_j].key;
				if (!key_down[_k]) {
					key_down[_k] = true;
					key_pressed[_k] = true;
					tu_keys_pressed.push(_k);
				}
			}
			_c++;
		}
		if (_c == 0) {
			_tx += _t[_i].pageX;
			_ty += _t[_i].pageY;
			touch_x[_tc] = _t[_i].pageX - _dx;
			touch_y[_tc] = _t[_i].pageY - _dy;
			_tc++;
		}
	}
	for (_i = 0; _i < _vl; _i++) {
		if (tu_vkeys[_i].count != 0) continue;
		if (!tu_vkeys[_i].down) continue;
		tu_vkeys[_i].down = false;
		_k = tu_vkeys[_i].key;
		if (key_down[_k]) {
			key_down[_k] = false;
			key_released[_k] = true;
			tu_keys_released.push(_k);
		}
	}
	touch_count = _tc;
	if (_tc != 0) {
		mouse_x = (_tx / _tc) - _dx;
		mouse_y = (_ty / _tc) - _dy;
		if (!mouse_down) {
			mouse_down = true;
			mouse_pressed = true;
		}
	} else if (mouse_down) {
		mouse_down = false;
		mouse_released = true;
	}
};
function __touchlistener__(e) {
	e.preventDefault();
	__touchvkey__(e.targetTouches);
};
//}
function tu_init () {
	if (document.addEventListener) {
		document.addEventListener("keydown", __keydownlistener__, false);
		document.addEventListener("keyup", __keyuplistener__, false);
		document.addEventListener("mousemove", __mousemovelistener__, false);
		document.addEventListener("mousedown", __mousedownlistener__, false);
		document.addEventListener("mouseup", __mouseuplistener__, false);
		document.addEventListener("touchstart", __touchlistener__, false);
		document.addEventListener("touchend", __touchlistener__, false);
		document.addEventListener("touchmove", __touchlistener__, false);
		document.addEventListener("touchenter", __touchlistener__, false);
		document.addEventListener("touchleave", __touchlistener__, false);
		document.addEventListener("touchcancel", __touchlistener__, false);
	} else {
		document.attachEvent("onkeydown", __keydownlistener__);
		document.attachEvent("onkeyup", __keyuplistener__);
		document.attachEvent("onmousemove", __mousemovelistener__);
		document.attachEvent("onmousedown", __mousedownlistener__);
		document.attachEvent("onmouseup", __mouseuplistener__);
	}
	// initialize keycodes
	for (var _k = 0; _k < 256; _k++) {
		key_down[_k] = key_pressed[_k] = key_released[_k] = false;
	}
}

function tu_loading_inc() { tu_loading++; tu_load_total++; }
function tu_loading_dec() { tu_loading--; }

function _$_(_id_) {
	return document.getElementById( _id_ );
}

function var_override(_what, _svar, _fget, _fset) {
	if (var_override_) {
		if (_what.hasOwnProperty(_svar)) return;
		Object.defineProperty(_what, _svar, {
			get: _fget,
			set: _fset
		});
	} else {
		if (_what.__lookupGetter__(_svar) != undefined) return;
		_what.__defineGetter__(_svar, _fget);
		_what.__defineSetter__(_svar, _fset);
	}
}

//{ Depth
function _tu_depth_find(_d) {
	var _tl = tu_depthi.length, _td, _ti;
	for (_ti = 0; _ti < _tl; _ti++) {
		_td = tu_depthi[_ti];
		if (_d > _td) return _ti;
	}
	return _tl;
}
function _tu_depth_new(_d) {
	var _i = _tu_depth_find(_d), _o = [];
	tu_depth.splice(_i, 0, _o);
	tu_depthi.splice(_i, 0, _d);
	return _i;
}
function tu_depth_add(_d, _o) {
	var _t = tu_depthi.indexOf(_d);
	if (_t == -1) _t = _tu_depth_new(_d); // create array if none
	tu_depth[_t].push(_o);
}
function tu_depth_delete(_d, _o) {
	var _t = tu_depth[tu_depthi.indexOf(_d)], _ti = _t.indexOf(_o);
	if (_ti == -1) return;
	_t.splice(_ti, 1);
}
function tu_depth_update() {
	var i, l = tu_depthu.length, o;
	if (l == 0) return;
	for (i = 0; i < l; i++) {
		o = tu_depthu[i];
		if (o.instance_active && o._depth !== undefined) tu_depth_delete(o._depth, o);
		o._depth = o._depthn;
		if (o.instance_active && o._depth !== undefined) tu_depth_add(o._depth, o);
		o._depthu = false;
	}
	tu_depthu = [];
}
// Accessors:
function tu_depth_get() { return this._depth; }
function tu_depth_set(_d) {
	if (this._depth == _d) return; // don't change on depth match
	this._depthn = _d;
	if (this._depthu) return;
	this._depthu = true;
	tu_depthu.push(this);
}
//}
//{ Types
function instance_list(_o) {
	var _t = _o._object_index_;
	if (tu_types[_t] == undefined) tu_types[_t] = [];
	return tu_types[_t];
}
function tu_type_add(_d, _o) {
	instance_list(_d).push(_o);
}
function tu_type_delete(_o, _p) {
	var _d = tu_types[_p], _t = _d.indexOf(_o);
	_d.splice(_t, 1);
}
function tu_type_get() { return this._object_index; }
//}
//{ Tileset functions
function tile_layer_find(_d) {
	var _tl = tu_tilesi.length, _td, _ti;
	for (_ti = 0; _ti < _tl; _ti++) {
		_td = tu_tilesi[_ti];
		if (_d > _td) return _ti;
	}
	return _tl;
}
function tile_layer_add(_d) {
	var _i = tile_layer_find(_d), _o = [];
	tu_tiles.splice(_i, 0, _o);
	tu_tilesi.splice(_i, 0, _d);
	return _o;
}
function tile(_s, _x, _y, _l, _t, _w, _h) {
	this.source = _s;
	this.x = _x;
	this.y = _y;
	this.left = _l;
	this.top = _t;
	this.width = _w;
	this.height = _h;
	this.width2 = _w;
	this.height2 = _h;
	this.sectors = [];
}
function tile_add(_b, _l, _t, _w, _h, _x, _y, _z) {
	var	_tx1 = Math.floor(_x / tu_tilez),
		_ty1 = Math.floor(_y / tu_tilez),
		_tx2 = Math.floor((_x + _w) / tu_tilez),
		_ty2 = Math.floor((_y + _h) / tu_tilez),
		_tt = new tile(_b, _x, _y, _l, _t, _w, _h),
		_tx, _ty, _ts,
		_d, _e = tu_tilesi.indexOf(_z);
	if (_e != -1) _d = tu_tiles[_e];
	else _d = tile_layer_add(_z);
	for (_tx = _tx1; _tx <= _tx2; _tx++) {
		if (_d[_tx] == null) _d[_tx] = [];
		for (_ty = _ty1; _ty <= _ty2; _ty++) {
			if (_d[_tx][_ty] == null) _d[_tx][_ty] = [];
			_ts = _d[_tx][_ty];
			_ts.push(_tt);
			_tt.sectors.push(_ts);
		}
	}
	return _tt;
}
function tile_find(_x, _y, _w, _h, _d) {
	var _xw = _x + _w,
		_yh = _y + _h,
		_r = [],
		_tx, _ty, _ti, _tl, _ts, _tt, _ta,
		_tx1, _ty1, _tx2, _ty2;
	_ti = tu_tilesi.indexOf(_d);
	if (_ti == -1) return _r;
	_ta = tu_tiles[_ti];
	_tx1 = Math.floor(_x / tu_tilez);
	_ty1 = Math.floor(_y / tu_tilez);
	_tx2 = Math.floor((_x + _w) / tu_tilez);
	_ty2 = Math.floor((_y + _h) / tu_tilez);
	for (_tx = _tx1; _tx <= _tx2; _tx++) {
		if (_ta[_tx] == null) continue;
		for (_ty = _ty1; _ty <= _ty2; _ty++) {
			if (_ta[_tx][_ty] == null) continue;
			_ts = _ta[_tx][_ty];
			_tl = _ts.length;
			for (_ti = 0; _ti < _tl; _ti++) {
				_tt = _ts[_ti];
				if (_tt.x >= _xw) continue;
				if (_tt.y >= _yh) continue;
				if (_tt.x + _tt.width2 < _x) continue;
				if (_tt.y + _tt.height2 < _y) continue;
				_r.push(_tt);
			}
		}
	}
	return _r;
}
function tile_delete(_t) {
	var _ti, _tl, _ts;
	_tl = _t.sectors.length;
	for (_ti = 0; _ti < _tl; _ti++) {
		_ts = _t.sectors[_ti];
		_ts.splice(_ts.indexOf(_t), 1);
	}
}
function tile_srender(_s) {
	var _ti, _tt;
	for (_ti = 0; _ti < _s.length; _ti++) {
		if (_s[_ti] == null) continue;
		_tt = _s[_ti];
		if (_tt.source == null) continue;
		if (_tt.source.image == null) continue;
		tu_context.drawImage(_tt.source.image, _tt.left, _tt.top, _tt.width, _tt.height, _tt.x - room_viewport_x, _tt.y - room_viewport_y, _tt.width2, _tt.height2);
	}
}
function tile_lrender(_l) {
	var _tx, _ty,
		_tx1 = Math.floor(room_viewport_x / tu_tilez),
		_tx2 = Math.floor((room_viewport_x + room_viewport_width) / tu_tilez),
		_ty1 = Math.floor(room_viewport_y / tu_tilez),
		_ty2 = Math.floor((room_viewport_y + room_viewport_height) / tu_tilez);
	for (_tx = _tx1; _tx <= _tx2; _tx++) {
		if (_l[_tx] == null) continue;
		for (_ty = _ty1; _ty <= _ty2; _ty++) {
			if (_l[_tx][_ty] == null) continue;
			tile_srender(_l[_tx][_ty]);
		}
	}
}
//} /Tileset functions
//{ Some events & accessors
function tu_id_get() { return this; }
function tu_parent_get() { return this._parent_index; }
function image_single_get() { return (this.image_speed == 0 ? this.image_index : -1); }
function image_single_set(_o) { this.image_speed = 0; this.image_index = _o; }
// Handles object size & sprite updates. Should get rid of this in favor of accessors.
function __handle_sprite__(_object_) {
	if (_object_.sprite_index == null) return;
	_object_.sprite_width = _object_.sprite_index.width;
	_object_.sprite_height = _object_.sprite_index.height;
	_object_.sprite_xoffset = _object_.sprite_index.xoffset;
	_object_.sprite_yoffset = _object_.sprite_index.yoffset;
	_object_.image_number = _object_.sprite_index.frames.length;
	_object_.image_index += _object_.image_speed;
	if (_object_.image_index >= _object_.image_number) _object_.image_index = _object_.image_index % _object_.image_number;
	if (_object_.image_index < 0) _object_.image_index = _object_.image_number - 1 + (_object_.image_index % _object_.image_number);
}
function __draw_self__() {
	draw_sprite_ext(this.sprite_index, this.image_index, this.x, this.y, this.image_xscale, this.image_yscale, this.image_angle, this.image_alpha);
}
//}
//{ Inherited event lookup functions.
// There's also a way to do this with much shorter code.
function on_creation_i() {
	for (var o = this.parent; o; o = o.parent)
	if (o.on_creation !== on_creation_i)
	return o.on_creation.apply(this);
}
function on_destroy_i() {
	for (var o = this.parent; o; o = o.parent)
	if (o.on_destroy !== on_destroy_i)
	return o.on_destroy.apply(this);
}
function on_step_i() {
	for (var o = this.parent; o; o = o.parent)
	if (o.on_step !== on_step_i)
	return o.on_step.apply(this);
}
function on_end_step_i() {
	for (var o = this.parent; o; o = o.parent)
	if (o.on_end_step !== on_end_step_i)
	return o.on_end_step.apply(this);
}
function on_draw_d() {
	__handle_sprite__(this);
	__draw_self__.apply(this);
}
function on_draw_i() {
	for (var o = this.parent; o; o = o.parent)
	if (o.on_draw !== on_draw_i)
	return o.on_draw.apply(this);
	on_draw_d.apply(this);
}
function on_collision_i() {
	for (var o = this.parent; o; o = o.parent)
	if (o.on_collision !== on_collision_i)
	return o.on_collision.apply(this);
}
function on_animationend_i() {
	for (var o = this.parent; o; o = o.parent)
	if (o.on_animationend !== on_animationend_i)
	return o.on_animationend.apply(this);
}
function on_roomstart_i() {
	for (var o = this.parent; o; o = o.parent)
	if (o.on_roomstart !== on_roomstart_i)
	return o.on_roomstart.apply(this);
}
function on_roomend_i() {
	for (var o = this.parent; o; o = o.parent)
	if (o.on_roomend !== on_roomend_i)
	return o.on_roomend.apply(this);
}
//} /Inherited event handles

// instance_init(this, object_index, parent_index, visible, depth, sprite, collideable, inner index)
// Universal object constructor:
function __instance_init__(_this, _oi, _p, _v, _d, _si, _c, _io) {
	_this._object_index = undefined;
	_this._object_index_ = _io;
	_this._depth = undefined;
	_this._depthn = undefined;
	_this._depthu = false;
	var_override(_this, 'depth', tu_depth_get, tu_depth_set );
	var_override(_this, 'object_index', tu_type_get, tu_idle );
	var_override(_this, 'image_single', image_single_get, image_single_set );
	var_override(_this, 'id', tu_id_get, tu_idle);
	var_override(_this, 'parent', tu_parent_get, tu_idle);
	_this._object_index = _oi;
	_this._parent_index = _p;
	_this.xstart = _this.xprevious = _this.x = 0;
	_this.ystart = _this.yprevious = _this.y = 0;
	_this.depthstart = _d;
	_this.image_angle = _this.direction = 0;
	_this.visible = _v;
	_this.image_yscale = _this.image_xscale = 1;
	_this.image_alpha = 1;
	_this.image_index = 0;
	_this.image_speed = 1;
	_this.sprite_index = _si;
	_this.speed = 0;
	_this.other = null;
	_this.collision_checking = _c;
	_this.persistent = false;
	_this.instance_active = false;
	// Instance-specific functions:
	_this.place_meeting = __place_meeting__;
	_this.move_towards_point = __move_towards_point__;
	_this.instance_destroy = __instance_destroy__;
	_this.draw_self = __draw_self__;
}
// Universal sprite constructor:
function __sprite_init__(_this, _name, _width, _height, _xofs, _yofs, _cshape, _crad, _cl, _cr, _ct, _cb, _frames) {
	_this.frames = [];
	var _frame, _fi;
	for (_fi = 0; _fi < _frames.length; _fi++) {
		_frame = new Image();
		if (_frames[_fi]) {
			tu_loading_inc();
			_frame.onload = tu_loading_dec;
			_frame.onerror = tu_loading_dec;
			_frame.src = _frames[_fi];
		}
		_this.frames.push(_frame);
	}
	_this.width = _width;
	_this.height = _height;
	_this.xoffset = _xofs;
	_this.yoffset = _yofs;
	_this.collision_shape = (_cshape == 'Circle' ? ct_circle : _cshape == 'Box' ? ct_box : 0);
	_this.collision_radius = _crad;
	_this.collision_left = _cl;
	_this.collision_right = _cr;
	_this.collision_top = _ct;
	_this.collision_bottom = _cb;
	tu_sprites.push(_this);
}
// Universal audio constructor:
function __audio_init__(_this, _name, _wav, _mp3, _ogg) {
	var _src = '';
	_this.type = 'none';
	if (tu_ogg_supported && (_ogg != '')) {
		_this.type = 'ogg';
		_src = _ogg;
	} else if (tu_mp3_supported && (_mp3 != '')) {
		_this.type = 'mp3';
		_src = _mp3;
	} else if (tu_wav_supported && (_wav != '')) {
		_this.type = 'wav';
		_src = _wav;
	}
	if (_src != '') {
		_this.audio = document.createElement('audio');
		_this.audio.setAttribute('src', _src);
	}
	tu_audios.push(_this);
}

function __background_init__(_this, _name, _file) {
	_this.image = new Image();
	tu_loading_inc();
	_this.image.onload = tu_loading_dec;
	_this.image.onerror = tu_loading_dec;
	_this.image.src = _file;
	tu_backgrounds.push(_this);
}

function __font_init__(_this, _name, _family, _size, _bold, _italic) {
	_this.family = _family;
	_this.size = _size;
	_this.bold = _bold;
	_this.italic = _italic;
	tu_fonts.push(_this);
}

// (this, name, width, height, speed, back. red, back. green, back. blue, background, back. tilex, back. tiley, back. stretch, view width, view height, view object, view hborder, view vborder)
function __room_start__(_this, _name, _rw, _rh, _rs, _br, _bg, _bb, _bi, _bx, _by, _bs, _vw, _vh, _vo, _vx, _vy) {
	_$_('tululoogame').innerHTML = "<canvas id='" + tu_canvas_id + "' width='" + _vw + "' height='" + _vh + "' style='" + tu_canvas_css + "'></canvas>";
	tu_canvas = _$_(tu_canvas_id);
	tu_context = tu_canvas.getContext('2d');
	room_current = _this;
	// generic:
	room_speed = _rs;
	room_width = _rw;
	room_height = _rh;
	// background color:
	room_background_color_red = _br;
	room_background_color_green = _bg;
	room_background_color_blue = _bb;
	// background image:
	room_background = _bi;
	room_background_x = 0;
	room_background_y = 0;
	room_background_tile_x = _bx;
	room_background_tile_y = _by;
	room_background_tile_stretch = _bs;
	// view:
	room_viewport_width = _vw;
	room_viewport_height = _vh;
	room_viewport_x = room_viewport_y = 0;
	room_viewport_object = _vo;
	room_viewport_hborder = _vx;
	room_viewport_vborder = _vy;
	// tiles:
	var _l, _b, _t, _i, _il, _tls_, i, l, d, o, a;
	_tls_ = _this.tiles; tu_tiles = []; tu_tilesi = [];
	for (_l = 0; _l < _tls_.length; _l++)
	for (_b = 1; _b < _tls_[_l].length; _b++)
	for (_t = 1; _t < _tls_[_l][_b].length; _t++)
	tile_add(_tls_[_l][_b][0], _tls_[_l][_b][_t][0], _tls_[_l][_b][_t][1], _tls_[_l][_b][_t][2], _tls_[_l][_b][_t][3], _tls_[_l][_b][_t][4], _tls_[_l][_b][_t][5], _tls_[_l][0]);
	// objects:
	tu_depth = []; tu_depthi = []; tu_depthu = []; tu_types = [];
	a = _this.objects;
	l = a.length;
	for (i = 0; i < l; i++) {
		d = a[i];
		d = d[0]; // temp.fix for rc2
		if (d.o === undefined) continue;
		o = instance_create_(d.x, d.y, d.o);
		if (d.s !== undefined) o.sprite_index = d.s;
		if (d.d !== undefined) o.direction = d.d;
		if (d.a !== undefined) o.image_angle = d.a;
		if (d.u !== undefined) o.image_xscale = d.u;
		if (d.v !== undefined) o.image_yscale = d.v;
		if (d.c !== undefined) d.c.apply(o);
	}
	// persistent objects:
	_l = tu_persist.length
	for (_t = 0; _t < _l; _t++) instance_activate(tu_persist[_t]);
	instance_foreach(function(o) {
		if (tu_persist.indexOf(o) != -1) return;
		o.on_creation();
	});
	tu_persist = [];
	//
	instance_foreach(function(o) {
		o.on_roomstart();
	});
}

function tu_preloader() {
	var _w = Math.min(400, (tu_canvas.width * 0.6) >> 0), _h = 16,
		_x = (tu_canvas.width - _w) >> 1, _y = (tu_canvas.height - _h) >> 1,
		_p = (tu_load_total - tu_loading) / tu_load_total,
		_s = "Loading resources: " + (tu_load_total - tu_loading) + "/" + (tu_load_total);
	tu_canvas.width = tu_canvas.width;
	tu_canvas.height = tu_canvas.height;
	tu_canvas.style.backgroundColor = "rgb(42, 42, 42)";
	tu_context.font = "italic 12px Verdana";
	tu_context.textAlign = "left";
	tu_context.textBaseline = "bottom";
	tu_context.fillStyle = tu_context.strokeStyle = "rgba(192, 192, 192, 1)";
	tu_context.fillRect(_x - 1, _y - 1, _w + 2, _h + 2);
	tu_context.fillStyle = tu_context.strokeStyle = "rgba(0, 0, 0, 1)";
	tu_context.fillRect(_x, _y, _w, _h);
	tu_context.fillStyle = tu_context.strokeStyle = "rgba(255, 255, 255, 1)";
	tu_context.fillRect(_x + 2, _y + 2, (_w - 4) * _p, _h - 4);
	tu_context.fillText(_s, _x, _y - 2);
}

function tu_render_back() {
	if (room_background == null) return;
	if (room_background_tile_stretch) {
		tu_context.drawImage(room_background, 0 - room_viewport_x, 0 - room_viewport_y, room_width, room_height);
		return;
	}
	var _bw, _bh, _bx, _by, _vx, _vy, _vw, _vh, _x1, _x2, _y1, _y2, _ht, _vt;
	_bw = room_background.width;
	_bh = room_background.height;
	_bx = room_background_x;
	if (room_background_tile_x) { _bx = _bx < 0 ? _bw - _bx % _bw : _bx % _bw; }
	_by = room_background_y;
	if (room_background_tile_y) { _bx = _by < 0 ? _bh - _by % _bh : _by % _bh; }
	//
	_vx = room_viewport_x;
	_vy = room_viewport_y;
	_vw = room_viewport_width;
	_vh = room_viewport_height;
	//
	_x1 = room_background_tile_x ? Math.floor(_vx / _bw) * _bw - _bx : -_bx;
	_x2 = room_background_tile_x ? Math.floor((_vx + _vw + _bw) / _bw) * _bw : _x1 + _bw;
	_y1 = room_background_tile_y ? Math.floor(_vy / _bh) * _bh - _by : -_by;
	_y2 = room_background_tile_y ? Math.floor((_vy + _vh + _bh) / _bh) * _bh : _y1 + _bh;
	for (_ht = _x1; _ht < _x2; _ht += _bw)
	for (_vt = _y1; _vt < _y2; _vt += _bh)
	tu_context.drawImage(room_background, _ht - _vx, _vt - _vy);
}
// @1.2.6
function instance_activate(_i) {
	if (_i.instance_active) return;
	for (var o = _i._object_index; o; o = o.parent) tu_type_add(o, _i);
	//tu_type_add(_i._object_index, _i);
	//if (_i.parent != null) tu_type_add(_i.parent, _i);
	tu_depth_add(_i._depth, _i);
	_i.instance_active = true;
}
// @1.2.6
function instance_deactivate(_i) {
	if (!_i.instance_active) return;
	for (var o = _i._object_index; o; o = o.parent) tu_type_delete(o._object_index_, _i);
	//tu_type_delete(_i, _i._object_index_);
	//if (_i.parent != null) tu_type_delete(_i, _i.parent._object_index_);
	tu_depth_delete(_i._depth, _i);
	_i.instance_active = false;
}
// @1.2.6 Performs function for all instances
function instance_foreach(_function) {
	var _d, _l, _o;
	for (_d in tu_depth) {
		_l = tu_depth[_d];
		for (_o = 0; _o < _l.length; _o++) _function(_l[_o]);
	}
}
// @1.2.6 Performs function for all instances on specific depth
function instance_fordepth(_depth, _function) {
	var _o, _d = tu_depthc[_depth], _l;
	if (_d == null) return;
	_l = _d.length;
	for (_o = 0; _o < _l; _o++) _function(_d[_o]);
}
// @1.2.6 Actions performed on room switch
function tu_room_switchto_(_o) {
	_o.on_roomend();
	if (!_o.persistent) return;
	tu_persist.push(_o);
	instance_deactivate(_o);
}
function tu_room_switchto(_dest) {
	tu_persist = [];
	instance_foreach(tu_room_switchto_);
	room_current = _dest;
	tu_room_to_go = null;
	room_current.start();
}
// @1.0.0 Global step event
function tu_step() {
	// object step events:
	tu_trash = [];
	var tu_deptho, tu_depthl, _obj_, _objd_, _h, _v;
	for (tu_depthd in tu_depth) {
		tu_depthc = tu_depth[tu_depthd];
		tu_depthl = tu_depthc.length;
		for (tu_deptho = 0; tu_deptho < tu_depthl; tu_deptho++) {
			_obj_ = tu_depthc[tu_deptho];
			// is viewport object?
			if (room_viewport_object != null && tu_viewport_inst == null && (_obj_.object_index == room_viewport_object || _obj_.parent == room_viewport_object)) {
				tu_viewport_inst = _obj_;
			}
			// step events:
			_obj_.on_step();
			// move object:
			if (_obj_.speed != 0) {
				_objd_ = _obj_.direction * tu_d2r;
				_obj_.x += _obj_.speed * Math.cos(_objd_);
				_obj_.y += _obj_.speed * Math.sin(_objd_);
			}
			// post-step events:
			_obj_.on_collision();
			_obj_.on_end_step();
			// post:
			_obj_.xprevious = _obj_.x;
			_obj_.yprevious = _obj_.y;
		}
	}
	// follow object
	if (tu_viewport_inst != null) {
		_h = min(room_viewport_hborder, room_viewport_width / 2);
		_v = min(room_viewport_vborder, room_viewport_height / 2);
		// hborder:
		if (tu_viewport_inst.x < room_viewport_x + _h) room_viewport_x = tu_viewport_inst.x - _h;
		if (tu_viewport_inst.x > room_viewport_x + room_viewport_width - _h) room_viewport_x = tu_viewport_inst.x - room_viewport_width + _h;
		// vborder:
		if (tu_viewport_inst.y < room_viewport_y + _v) room_viewport_y = tu_viewport_inst.y - _v;
		if (tu_viewport_inst.y > room_viewport_y + room_viewport_height - _v) room_viewport_y = tu_viewport_inst.y - room_viewport_height + _v;
		// limits:
		room_viewport_x = Math.max(0, Math.min(room_viewport_x, room_width - room_viewport_width)) >> 0;
		room_viewport_y = Math.max(0, Math.min(room_viewport_y, room_height - room_viewport_height)) >> 0;
	}
}

function tu_draw() {
	// clear canvas:
	if (room_background_color_show) {
		tu_canvas.width = tu_canvas.width;
		tu_canvas.height = tu_canvas.height;
		// set background color:
		tu_canvas.style.backgroundColor = "rgb(" + room_background_color_red + "," + room_background_color_green + "," + room_background_color_blue + ")";
	}
	tu_render_back();
	tile_layer_last = 0;
	var tu_depthc, tu_depthv, tu_deptho, tu_depthl, _obj_;
	for (tu_depthd in tu_depth) {
		tu_depthc = tu_depth[tu_depthd];
		tu_depthv = tu_depthi[tu_depthd];
		for (; tu_tilesi[tile_layer_last] >= tu_depthv && tile_layer_last < tu_tiles.length; tile_layer_last++)
		{
			tile_lrender(tu_tiles[tile_layer_last]);
		}
		tu_depthl = tu_depthc.length;
		for (tu_deptho = 0; tu_deptho < tu_depthl; tu_deptho++) {
			_obj_ = tu_depthc[tu_deptho];
			if (_obj_.visible) _obj_.on_draw();
			_obj_.on_animationend();
		}
	}
	// render remaining tile layers:
	for (; tile_layer_last < tu_tiles.length; tile_layer_last++) {
		tile_lrender(tu_tiles[tile_layer_last]);
	}
}

function tu_prestep() {
	// clear mouse states and keypressed / keyrelesed statuses
	mouse_pressed = false;
	mouse_released = false;
	var _k, _r, _obj_;
	for (_k = 0; _k < tu_keys_pressed.length; _k++) key_pressed[tu_keys_pressed[_k]] = false;
	for (_k = 0; _k < tu_keys_released.length; _k++) key_released[tu_keys_released[_k]] = false;
	tu_keys_pressed = [];
	tu_keys_released = [];
	// remove objects from destroy stack
	for (_r = 0; _r < tu_trash.length; _r++) {
		_obj_ = tu_trash[_r];
		if (tu_modal == _obj_) tu_modal = null;
		_obj_.depth = undefined;
		tu_type_delete(_obj_, _obj_._object_index_);
		if (_obj_.parent != null) tu_type_delete(_obj_, _obj_.parent._object_index_);
		_obj_.on_destroy();
	}
}

function tu_loop() {
	// calculate render time
	tu_frame_time = tu_gettime();
	tu_elapsed = (tu_frame_time - tu_prev_frame_time);
	tu_frame_step += tu_elapsed;
	tu_frame_el += tu_elapsed;
	// continue game with the UN-Pause key
	if (tu_paused && keyboard_check_pressed(tu_unpausekey)) tu_paused = false;
	//
	if (tu_room_to_go != null && tu_canvas == null) tu_room_switchto(tu_room_to_go);
	// render game:
	if (tu_frame_step >= 1000 / room_speed && tu_loading == 0 && tu_canvas != null && !tu_paused) {
		tu_frame_count++;
		tu_elapsed = tu_frame_time - tu_prev_cycle_time;
		tu_prev_cycle_time = tu_frame_time;
		tu_frame_step -= 1000 / room_speed;
		if (tu_frame_step < 0 || tu_frame_step > 1024) tu_frame_step = 0;
		// start next room, if any:
		if (tu_room_to_go != null) tu_room_switchto(tu_room_to_go);
		//
		tu_redraw = tu_redraw_auto;
		if (tu_modal != null) {
			tu_modal.on_step();
			if (tu_modal != null) tu_modal.on_end_step();
		} else tu_step();
		tu_depth_update();
		if (tu_redraw) {
			if (tu_modal == null || tu_modaldraw) tu_draw();
			else tu_modal.on_draw();
		}
		tu_depth_update();
		tu_prestep();
		tu_depth_update();
	} else if (tu_loading > 0) tu_preloader();
	// calculate fps:
	if (tu_frame_el >= Math.floor(200 / room_speed) * 5 * room_speed)
	{
		fps = Math.ceil(tu_frame_count * 1000 / tu_frame_el);
		if (fps > room_speed) fps = room_speed;
		tu_frame_el = tu_frame_count = 0;
	}
	// repeat
	tu_prev_frame_time = tu_frame_time;
	setTimeout(tu_gameloop, 5);
}
tu_init();

/***********************************************************************
 * EXTENSIONS
 ***********************************************************************/


/***********************************************************************
 * SPRITES
 ***********************************************************************/
function __SChiqueiro() { 
__sprite_init__(this, SChiqueiro, 400, 256, 0, 0, 'Box', 200, 0, 400, 0, 256, ['img/SChiqueiro_0.png']);
}; var SChiqueiro = new __SChiqueiro();

function __SPig() { 
__sprite_init__(this, SPig, 48, 40, 0, 0, 'Box', 24, 0, 48, 0, 40, ['img/SPig_0.png']);
}; var SPig = new __SPig();

function __SHappyPig() { 
__sprite_init__(this, SHappyPig, 48, 44, 0, 0, 'Box', 24, 0, 48, 0, 44, ['img/SHappyPig_0.png']);
}; var SHappyPig = new __SHappyPig();

function __SuperPorco() { 
__sprite_init__(this, SuperPorco, 96, 67, 0, 0, 'Box', 48, 0, 96, 0, 67, ['img/SuperPorco_0.png']);
}; var SuperPorco = new __SuperPorco();

function __SPigAngel() { 
__sprite_init__(this, SPigAngel, 96, 70, 0, 0, 'Box', 48, 0, 96, 0, 70, ['img/SPigAngel_0.png','img/SPigAngel_1.png','img/SPigAngel_2.png','img/SPigAngel_3.png']);
}; var SPigAngel = new __SPigAngel();

function __SDog2() { 
__sprite_init__(this, SDog2, 82, 69, 0, 0, 'Box', 41, 0, 82, 0, 69, ['img/SDog2_0.png','img/SDog2_1.png','img/SDog2_2.png']);
}; var SDog2 = new __SDog2();

function __SFlames() { 
__sprite_init__(this, SFlames, 64, 64, 0, 0, 'Box', 32, 0, 64, 0, 64, ['img/SFlames_0.png','img/SFlames_1.png','img/SFlames_2.png','img/SFlames_3.png','img/SFlames_4.png','img/SFlames_5.png','img/SFlames_6.png','img/SFlames_7.png','img/SFlames_8.png','img/SFlames_9.png','img/SFlames_10.png','img/SFlames_11.png','img/SFlames_12.png','img/SFlames_13.png','img/SFlames_14.png','img/SFlames_15.png','img/SFlames_16.png','img/SFlames_17.png','img/SFlames_18.png','img/SFlames_19.png','img/SFlames_20.png','img/SFlames_21.png','img/SFlames_22.png','img/SFlames_23.png','img/SFlames_24.png','img/SFlames_25.png','img/SFlames_26.png','img/SFlames_27.png','img/SFlames_28.png','img/SFlames_29.png','img/SFlames_30.png','img/SFlames_31.png','img/SFlames_32.png','img/SFlames_33.png','img/SFlames_34.png','img/SFlames_35.png']);
}; var SFlames = new __SFlames();

function __SButtonsPM() { 
__sprite_init__(this, SButtonsPM, 32, 100, 0, 0, 'Box', 16, 0, 32, 0, 100, ['img/SButtonsPM_0.png']);
}; var SButtonsPM = new __SButtonsPM();

function __SPigShield() { 
__sprite_init__(this, SPigShield, 72, 73, 0, 0, 'Box', 36, 0, 72, 0, 73, ['img/SPigShield_0.png']);
}; var SPigShield = new __SPigShield();

function __SDrop() { 
__sprite_init__(this, SDrop, 19, 32, 0, 0, 'Box', 9, 0, 19, 0, 32, ['img/SDrop_0.png']);
}; var SDrop = new __SDrop();

function __SPigFalando() { 
__sprite_init__(this, SPigFalando, 48, 44, 0, 0, 'Box', 24, 0, 48, 0, 44, ['img/SPigFalando_0.png']);
}; var SPigFalando = new __SPigFalando();

function __SWalkPig() { 
__sprite_init__(this, SWalkPig, 88, 60, 0, 0, 'Box', 44, 0, 88, 0, 60, ['img/SWalkPig_0.png','img/SWalkPig_1.png','img/SWalkPig_2.png','img/SWalkPig_3.png','img/SWalkPig_4.png','img/SWalkPig_5.png','img/SWalkPig_6.png','img/SWalkPig_7.png','img/SWalkPig_8.png','img/SWalkPig_9.png','img/SWalkPig_10.png','img/SWalkPig_11.png','img/SWalkPig_12.png','img/SWalkPig_13.png','img/SWalkPig_14.png','img/SWalkPig_15.png','img/SWalkPig_16.png','img/SWalkPig_17.png','img/SWalkPig_18.png','img/SWalkPig_19.png','img/SWalkPig_20.png','img/SWalkPig_21.png','img/SWalkPig_22.png','img/SWalkPig_23.png']);
}; var SWalkPig = new __SWalkPig();

function __SEspiga() { 
__sprite_init__(this, SEspiga, 64, 64, 0, 0, 'Box', 32, 0, 64, 0, 64, ['img/SEspiga_0.png']);
}; var SEspiga = new __SEspiga();

function __SCoinBrown() { 
__sprite_init__(this, SCoinBrown, 64, 64, 0, 0, 'Box', 32, 0, 64, 0, 64, ['img/SCoinBrown_0.png']);
}; var SCoinBrown = new __SCoinBrown();

function __SCoinRed() { 
__sprite_init__(this, SCoinRed, 64, 64, 0, 0, 'Box', 32, 0, 64, 0, 64, ['img/SCoinRed_0.png']);
}; var SCoinRed = new __SCoinRed();

function __SCoinBlue() { 
__sprite_init__(this, SCoinBlue, 64, 64, 0, 0, 'Box', 32, 0, 64, 0, 64, ['img/SCoinBlue_0.png']);
}; var SCoinBlue = new __SCoinBlue();

function __SCoinGreen() { 
__sprite_init__(this, SCoinGreen, 64, 64, 0, 0, 'Box', 32, 0, 64, 0, 64, ['img/SCoinGreen_0.png']);
}; var SCoinGreen = new __SCoinGreen();

function __SApple() { 
__sprite_init__(this, SApple, 64, 64, 0, 0, 'Box', 32, 0, 64, 0, 64, ['img/SApple_0.png']);
}; var SApple = new __SApple();

function __SPan() { 
__sprite_init__(this, SPan, 96, 35, 0, 0, 'Box', 48, 0, 96, 0, 35, ['img/SPan_0.png']);
}; var SPan = new __SPan();

function __SSausage() { 
__sprite_init__(this, SSausage, 48, 36, 0, 0, 'Box', 24, 0, 48, 0, 36, ['img/SSausage_0.png']);
}; var SSausage = new __SSausage();

function __SPigMedo() { 
__sprite_init__(this, SPigMedo, 48, 47, 0, 0, 'Box', 24, 0, 48, 0, 47, ['img/SPigMedo_0.png']);
}; var SPigMedo = new __SPigMedo();

function __SDog() { 
__sprite_init__(this, SDog, 96, 115, 0, 0, 'Box', 48, 0, 96, 0, 115, ['img/SDog_0.png','img/SDog_1.png','img/SDog_2.png','img/SDog_3.png']);
}; var SDog = new __SDog();

function __SPigFogo() { 
__sprite_init__(this, SPigFogo, 96, 108, 0, 0, 'Box', 48, 0, 96, 0, 108, ['img/SPigFogo_0.png']);
}; var SPigFogo = new __SPigFogo();

function __SPigFogoApagado() { 
__sprite_init__(this, SPigFogoApagado, 96, 101, 0, 0, 'Box', 48, 0, 96, 0, 101, ['img/SPigFogoApagado_0.png']);
}; var SPigFogoApagado = new __SPigFogoApagado();

function __SPigWalking() { 
__sprite_init__(this, SPigWalking, 96, 84, 0, 0, 'Box', 48, 0, 96, 0, 84, ['img/SPigWalking_0.png','img/SPigWalking_1.png','img/SPigWalking_2.png','img/SPigWalking_3.png']);
}; var SPigWalking = new __SPigWalking();



/***********************************************************************
 * SOUNDS
 ***********************************************************************/
function __SndSuperPig() { 
__audio_init__(this, SndSuperPig, 'aud/superpig.wav', '', '');
}; var SndSuperPig = new __SndSuperPig();

function __SndPigSqueak() { 
__audio_init__(this, SndPigSqueak, '', 'aud/pig-squeak.mp3', '');
}; var SndPigSqueak = new __SndPigSqueak();

function __SndMoedas() { 
__audio_init__(this, SndMoedas, '', 'aud/moedas.mp3', '');
}; var SndMoedas = new __SndMoedas();

function __SndHorn() { 
__audio_init__(this, SndHorn, '', 'aud/Horn.mp3', '');
}; var SndHorn = new __SndHorn();

function __SndPigSqueak2() { 
__audio_init__(this, SndPigSqueak2, '', 'aud/SPigSqueak2.mp3', '');
}; var SndPigSqueak2 = new __SndPigSqueak2();



/***********************************************************************
 * MUSICS
 ***********************************************************************/
function __Music1() { 
__audio_init__(this, Music1, '', 'aud/Brett Detar-The Devil_s Gotta_ Earn.mp3', '');
}; var Music1 = new __Music1();

function __Music2() { 
__audio_init__(this, Music2, '', 'aud/mypantiesgethotter.mp3', '');
}; var Music2 = new __Music2();



/***********************************************************************
 * BACKGROUNDS
 ***********************************************************************/
function __BackFarm4() { 
__background_init__(this, BackFarm4, 'img/Farm4.png')}; var BackFarm4 = new __BackFarm4();

function __BackFarm5() { 
__background_init__(this, BackFarm5, 'img/Farm5.png')}; var BackFarm5 = new __BackFarm5();

function __BackTituloFase1() { 
__background_init__(this, BackTituloFase1, 'img/TituloFase1.png')}; var BackTituloFase1 = new __BackTituloFase1();

function __BackTituloFase2() { 
__background_init__(this, BackTituloFase2, 'img/TituloFase2.png')}; var BackTituloFase2 = new __BackTituloFase2();

function __BackTituloFase3() { 
__background_init__(this, BackTituloFase3, 'img/TituloFase3.png')}; var BackTituloFase3 = new __BackTituloFase3();

function __BackFarm() { 
__background_init__(this, BackFarm, 'img/Farm1.png')}; var BackFarm = new __BackFarm();

function __BackFarm2() { 
__background_init__(this, BackFarm2, 'img/Farm2.png')}; var BackFarm2 = new __BackFarm2();

function __BackFarm3() { 
__background_init__(this, BackFarm3, 'img/Farm3.png')}; var BackFarm3 = new __BackFarm3();

function __BackTituloFase5() { 
__background_init__(this, BackTituloFase5, 'img/TituloFase5.png')}; var BackTituloFase5 = new __BackTituloFase5();

function __BackCreditos() { 
__background_init__(this, BackCreditos, 'img/TituloFim.png')}; var BackCreditos = new __BackCreditos();

function __BackTituloFase4() { 
__background_init__(this, BackTituloFase4, 'img/TituloFase4.png')}; var BackTituloFase4 = new __BackTituloFase4();

function __BackTituloFase3b() { 
__background_init__(this, BackTituloFase3b, 'img/TituloFase3B.png')}; var BackTituloFase3b = new __BackTituloFase3b();

function __BackFim() { 
__background_init__(this, BackFim, 'img/fimdojogo.png')}; var BackFim = new __BackFim();



/***********************************************************************
 * FONTS
 ***********************************************************************/
function __ArialB16() { 
__font_init__(this, ArialB16, 'Arial', 40, 1, 0)}; var ArialB16 = new __ArialB16();



/***********************************************************************
 * OBJECTS
 ***********************************************************************/
function __OBall() {
__instance_init__(this, OBall, null, 1, 0, SFlames, 1, 0);
this.on_creation = on_creation_i;
this.on_destroy = on_destroy_i;
this.on_step = on_step_i;
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = on_draw_i;
}; var OBall = new __OBall();

function __OPig() {
__instance_init__(this, OPig, null, 1, 0, SPig, 1, 1);
this.on_creation = on_creation_i;
this.on_destroy = on_destroy_i;
this.on_step = on_step_i;
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = on_draw_i;
}; var OPig = new __OPig();

function __OCtrlFase1() {
__instance_init__(this, OCtrlFase1, null, 1, 1, null, 0, 3);
this.on_creation = function() {
with(this) {
this.bola=0;
this.pig=0;
this.indexpig=0;
this.keypig=0;
this.A=0;
this.B=0;
this.C=0;
this.linha=room_height;
this.n_fireball = 8;
this.pseudo_tempo = 0;

this.osporcos = 0;//(instance_list(OPig));
this.boxbanner = 0;//(instance_list(OCoordenadas));
this.placar = 0;//(instance_list(OPlacar));
}
};
this.on_destroy = on_destroy_i;
this.on_step = function() {
with(this) {
//-1 = setup
//0 = sorteio e preparação
//1 = loop move bola e aguarda keyboard_check
//2 = animação porco sorrindo




var k;
var n;

if (-1 == G_state) {

 if (GPlayerName == "noname") {
   leiaCookie();
   GPlayerName = GPlayerName + (Math.floor(100000*Math.random())).toString();
 }
 
 GSala = 1;
 GFase = 1;
 GPontosFase = 0;
 callPHP(2);
 GFase = 1;
 
 boxbanner = (instance_list(OCoordenadas))[0];
 osporcos = (instance_list(OPig));
 G_state = 0;
 G_speed = 2.0;
 linha = ((instance_list(OPig))[0]).y - 50;
 placar = (instance_list(OPlacar))[0];
 placar.px = room_width - 81;
 placar.py = 1;
 sound_play(Music1);
 sound_volume(Music1,0.5);
 return;
}


if (0==G_state) {

  boxbanner.cx = 1;
  boxbanner.cy = room_height - 150;
  boxbanner.cy = 1;

  n = (instance_list(OPig)).length;

  for (k = 0; k < n; k++){
    (osporcos[k]).sprite_index = SPig;
  }		
		
  bola = instance_list(OBall)[0];

  indexpig = irandom(9); /* sorteio de 1 a 9 */
  pig = osporcos[indexpig-1];

  boxbanner.meutexto  = "( ? , 0)";
  boxbanner.meutexto2 = "(    , 0)";
  boxbanner.tempo = -1;
  boxbanner.ok = -1;

 bola.x = pig.x + irandom(200) - 100;
 bola.y = 30;
 if (bola.x < 10) bola.x = irandom(100);
 C = 3.5 * fps;
 if (C < 30) {C = C * 3;}
 A = (pig.x - bola.x)/C;
 B = (pig.y - bola.y)/C;


  G_speed = G_speed * 1.07;
  G_state = 1;

  linha = linha - 20;
  n_fireball = n_fireball - 1;
  G_lucro = Math.floor(room_height / linha);


  if (n_fireball < 1) {

	callPHP(1);

    G_state = -1;

    if (GPontosFase > 0)
       room_goto_next();
	else
	   room_goto (RoomTituloFase1);

	return;
  }
}


if (1==G_state) {

 bola.x += A;
 bola.y += B;
 
  k = -1;

  if (bola.y < linha) {

	if (keyboard_check_released (vk_1)){k=1;
	   osporcos[0].sprite_index = SPigShield;}
	if (keyboard_check_released (vk_2)){k=2;
	   osporcos[1].sprite_index = SPigShield;}
	if (keyboard_check_released (vk_3)){k=3;
	   osporcos[2].sprite_index = SPigShield;}
	if (keyboard_check_released (vk_4)){k=4;
	   osporcos[3].sprite_index = SPigShield;}
	if (keyboard_check_released (vk_5)){k=5;
	   osporcos[4].sprite_index = SPigShield;}
	if (keyboard_check_released (vk_6)){k=6;
	   osporcos[5].sprite_index = SPigShield;}
	if (keyboard_check_released (vk_7)){k=7;
	   osporcos[6].sprite_index = SPigShield;}
	if (keyboard_check_released (vk_8)){k=8;
	   osporcos[7].sprite_index = SPigShield;}
	if (keyboard_check_released (vk_9)){k=9;
	   osporcos[8].sprite_index = SPigShield;}
  }
   
  if (keyboard_check_released (vk_p)){
       n_fireball = 0;
	   return;
  }

  if ((k > 0) ||  (bola.y >= pig.y)) {
	 G_state = 2;
	 keypig = k;
	 boxbanner.ok = (k == indexpig);
     boxbanner.meutexto = "(" + k + ",0)";
	 boxbanner.tempo = 30000;
	 G_placar += G_lucro * boxbanner.ok;
	 
	 GPontosFase++;
	 
	 if (k != indexpig)
	    osporcos[indexpig-1].sprite_index = SPigMedo;
	}
}

if (2==G_state) {

 bola.x += A;
 bola.y += B;

   if (bola.y >= pig.y)
      if (keypig != indexpig) { // errou, crie anjo
	     GEnergia = GEnergia - 0.5;
         G_state = 3;
         bola.x = 0;
         bola.y = room_height + 100;
		 --indexpig;
         osporcos[indexpig].sprite_index = SPigAngel;
		 if (irandom(10)<3)
		    sound_play (SndPigSqueak);
		 if (indexpig > 5)
		    keypig = 4;
		 else
		    keypig = 6;
	  } else {
         G_state = 0;
	     osporcos[indexpig].sprite_index = SPig;
	  }
}

if (3==G_state) {

   osporcos[indexpig].y -= 2;
   if (osporcos[indexpig].y < osporcos[keypig].y - 160) {
      G_state = 0;
	  osporcos[indexpig].y = osporcos[keypig].y;
	  osporcos[indexpig].sprite_index = SPig;
   }   
}
}
};
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = function() {
if (this.visible == 1) {
__handle_sprite__(this);
with(this) {
draw_set_color(0,0,200);
draw_set_linewidth(5);
draw_line(5,linha,room_width,linha);
draw_set_alpha(0.1);
draw_rectangle(5,linha,room_width,room_height,0);
draw_set_alpha(1.0);

drawCartesian (10,10,room_width-10, room_height-1,11,10,-1,9);

if (3!=G_state) {
  i = 0;
  oy = osporcos[0].y;
  pseudo_tempo = pseudo_tempo + 0.075;
  for (i = 1; i < osporcos.length; i = i + 1)
    osporcos[i].y = oy + 3 * Math.sin(pseudo_tempo + osporcos[i].x * 3 / room_width);
}
}
}
};
}; var OCtrlFase1 = new __OCtrlFase1();

function __OCoordenadas() {
__instance_init__(this, OCoordenadas, null, 1, 0, null, 0, 4);
this.on_creation = function() {
with(this) {
this.tempo = 0;
this.utempo = 400;
this.pisca = 1;
this.meutexto = "ueba";
this.meutexto2 = "";
this.ok = 0;
this.cx = 0;
this.cy = 0;
}
};
this.on_destroy = on_destroy_i;
this.on_step = on_step_i;
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = function() {
if (this.visible == 1) {
__handle_sprite__(this);
with(this) {
   
  if (utempo > 1) {
    utempo -= tu_elapsed;
  } else {
    pisca = -pisca;
	utempo = 300;
  }

    draw_set_font(ArialB16);

    if (ok == -1)
      draw_set_color(190,190,250);
    else if (ok == 0)
      draw_set_color(250,100,100);
    else
      draw_set_color(100,250,100);

    //draw_rectangle(room_width - 150,50,room_width-5,140,0);
    draw_rectangle(cx,cy,cx+145,cy+90,0);

    draw_set_color(0,0,0);
   
  if ((pisca > 0) || (ok > -1))  
    draw_text(cx+20,cy+20,this.meutexto);
  else
    draw_text(cx+20,cy+20,this.meutexto2);
    //draw_text(room_width - 130,70,this.meutexto);


}
}
};
}; var OCoordenadas = new __OCoordenadas();

function __OCtrlFase3() {
__instance_init__(this, OCtrlFase3, null, 1, 0, null, 0, 15);
this.on_creation = function() {
with(this) {
this.parabolas=[0.5, 0.0, 0.5, 0.5, 0.5, 1.5, 1, 0, 1, 1, 1, 2];
this.posx = 0;
this.posy = 0;
this.lenx = 500;
this.leny = 500;
this.texto = "( 2, ? )";
this.flagminus = 1;
this.vx = 0;
this.vy = 0;
this.porco = 0;
this.dog = 0;
this.asalsicha = 0;
this.nsalsichas = 5;
this.nloops = 12;
this.boxbanner = 0;//(instance_list(OCoordenadas));
this.k = 0;
this.fpisca = 0;
this.tpisca = 0;
}
};
this.on_destroy = on_destroy_i;
this.on_step = function() {
with(this) {
tpisca = tpisca - tu_elapsed;
if (tpisca < 0) {
   tpisca = 250;
   fpisca = 1 - fpisca;
}

if (G_state == -1) {

   GSala = 3;
   GFase = 3;
   GPontosFase = 0;
  
   placar = (instance_list(OPlacar))[0];
   placar.px = room_width - 81;
   placar.py = 1;
   porco=instance_create(room_width - 100,room_height * 0.9,OPig);
   boxbanner = (instance_list(OCoordenadas))[0];
   boxbanner.meutexto = " ";
   boxbanner.meutexto2 = " ";
   boxbanner.ok = -1;  

    if(0==(instance_list(ODog)).length)
       dog=instance_create(room_width - 140,room_height*0.1,ODog);

    dog.targetx = porco.x - 20;
	dog.targety = porco.y;

    asalsicha = instance_create (0,0,OSausage);
	asalsicha.visible = false;
    asalsicha.dog = dog;

    G_state = 0;
}


if (0 == G_state) {

    porco.sprite_index = SPig;

	nloops = nloops - 1;

    callPHP(1);	
	
    if (nloops < 1) {

	   G_state = -1;

       if (GPontosFase > 2)
          room_goto_next();
	   else
	      room_goto (RoomTituloFase3);
		  
	   return;
	}

    flagminus = 1;

    dog.x = room_width - 10 - irandom(100);
    dog.y = room_height*0.1;
    dog.chegou = 0;
	dog.walking = true;

   
	idx = irandom(6);
	if (idx < 6) {
	   GA = parabolas[idx * 2];
	   GB = parabolas[idx * 2 + 1];
	   if (Math.random() < .5) GA = -GA;
	} else {
	  GA = 0;
      GB = irandom(2);
	}
    if (Math.random() < .5) GB = -GB;	   
	GC = irandom(3) - 1;
	
	if (GA < 0) GC = -GC;
	
	vy = 10;
	while ((vy > 4) || (vy < -4)) {
      vx = 4-irandom (8);
      vy = vx * (vx * GA + GB) + GC;
	}
	
    boxbanner.meutexto  = "( " + vx + ", ? )";
    boxbanner.meutexto2 = "( " + vx + ",   )";
    //boxbanner.meutexto2 = "( " + vx + "," + vy + ")";
	boxbanner.cx = room_width * 0.75;
	boxbanner.cy = room_height * 0.1;
    boxbanner.utempo = 300;
    boxbanner.ok = -1;

    G_state = 1;
	
}

if (1 == G_state) {
    
    k = -5;
	if (keyboard_check_released (vk_0)) k = 0;
	if (keyboard_check_released (vk_1)) k = 1;
	if (keyboard_check_released (vk_2)) k = 2;
	if (keyboard_check_released (vk_3)) k = 3;
	if (keyboard_check_released (vk_4)) k = 4;
		   
	if (keyboard_check_released (173) || keyboard_check_released (189))
	   flagminus = -1;

   // jogador quer abandonar a fase
   if (keyboard_check_released (vk_p)){
       nloops = 0;
	   return;
   }


  if (keyboard_check_released (vk_s) && (asalsicha.visible == false)) {
      asalsicha.x = dog.x;
	  asalsicha.y = dog.y;
	  asalsicha.visible = true;
	  asalsicha.tempo = 5000;
	  dog.walking = false;
  }
  

   // digitou alguma coisa
   if (k > -5) {
      boxbanner.meutexto  = "( " + vx + ", " + (k * flagminus) + ")";
	  
      boxbanner.ok = ((k*flagminus) == vy); 
	  
      G_state = 2;
	  return;
   }
   
	if (1 == dog.chegou) {
	   GEnergia = GEnergia - 0.5;
	   G_state = 0;
	   return;
    }
   
}

if (2 == G_state) {

	if (boxbanner.ok) {

      GPontosFase++;
	  if (0 == GPontosFase % 3)
	     GEnergia = GEnergia + 1;

      sound_play(SndMoedas);
	  
	  G_placar += 10;
	  G_state   = 0;		  

	  return;
	}
	   
	if (1 == dog.chegou) {
	   GEnergia = GEnergia - 0.5;
	   G_state = 0;
	   return;
    }
	
}
}
};
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = function() {
if (this.visible == 1) {
__handle_sprite__(this);
with(this) {
midx = lenx / 2;
midy = leny / 2;

px = lenx/10;
py = leny/10;

tu_draw_font="20px sans-serif"

for (i = 1; i < 10; i++) {

   draw_set_color(90,90,90);
   draw_line (i*px, posy, i*px, posy + leny);
   draw_line (posx, i*py, posx + lenx, i*py);

   draw_set_color (0,0,0);   
   draw_text (i*px, midy, " "+(i-5));
   draw_text (midx, i*px, " "+(5-i));
}

draw_set_linewidth(5);
draw_line (midx, posy, midx, posy + leny);
draw_line (posx, midy, posx + lenx, midy);


i = -4;
y = i * (i * GA + GB) + GC;
cx = midx + i*px;

draw_set_linewidth(6);
while (i < 5) {
      
   if ((porco.sprite_index == SPigFalando) && (i == vx) && fpisca) {
      draw_set_color (255,0,0);
      draw_circle    (cx,midy-y*py,11,0);
   } else {
      draw_set_color (200,0,200);
      draw_circle    (cx,midy-y*py,6,0);
   }
   
   j = i + 0.5;
   y2 = j * (j * GA + GB) + GC;
   
   draw_set_color(0,0,250);
   draw_line (cx,midy-y*py,cx+(px/2),midy-y2*py);
   
   aux = j + 0.5;
   y3 = aux * (aux * GA + GB) + GC;
   
   draw_line (cx+(px/2),midy-y2*py,cx+px,midy-y3*py);

   i++;
   y = y3;
   cx = cx + px;
}


tu_draw_font="32px sans-serif"
draw_text(600,100,texto);

if ((porco.y - dog.y) < 250)
   porco.sprite_index = SPigFalando;
if ((porco.y - dog.y) < 130)
   porco.sprite_index = SPigMedo;
}
}
};
}; var OCtrlFase3 = new __OCtrlFase3();

function __OEspere() {
__instance_init__(this, OEspere, null, 1, 0, null, 0, 16);
this.on_creation = function() {
with(this) {
this.tempo = 10000;

tu_draw_font = "bold 72px arial"
draw_set_color(250,250,0);

if (room_current == RoomFIM)
   this.tempo = 15000;
}
};
this.on_destroy = on_destroy_i;
this.on_step = on_step_i;
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = function() {
if (this.visible == 1) {
__handle_sprite__(this);
with(this) {
   
tempo -= tu_elapsed;

if ((tempo < 1) || (tu_keys_pressed.length > 0)) {

   if (room_current == RoomFIM) {
      if (tempo < 1)
         room_goto(RoomFase1); 
	  else
	     return;
   }
   
   room_goto_next();
   //room_goto(RoomFase5); 
   return;
}
   
draw_text(room_width/2, room_height * 0.75, " " + Math.ceil(tempo/1000));
}
}
};
}; var OEspere = new __OEspere();

function __OCtrlFase2() {
__instance_init__(this, OCtrlFase2, null, 1, 0, null, 0, 17);
this.on_creation = function() {
with(this) {
this.bola=0;
this.pig=0;
this.indexpig=0;
this.A=0;
this.B=0;
this.C=0;
this.flagminus = 0;
this.flagsuperporco = 0;
this.linha = 0;
this.n_fireball = 8;
this.pseudo_tempo = 0;

this.osporcos = (instance_list(OPig));
this.boxbanner = (instance_list(OCoordenadas));
this.placar = 0;
}
};
this.on_destroy = on_destroy_i;
this.on_step = function() {
with(this) {

var k;
var n;

if (-1 == G_state) {

 GSala = 2;
 GFase = 2;
 GPontosFase = 0;

 boxbanner = (instance_list(OCoordenadas)[0]);
 G_state = 0;
 G_speed = 3.5;
 linha = room_width * 0.8;//((instance_list(OPig)[0]).x) - 100;
 placar = (instance_list(OPlacar))[0];
 placar.px = room_width - 81;
 placar.py = 1;
 
  n = (room_height - 20) / 10;
  aux = 10 + n - (SPig.height/2);
  for (k = 0; k < 9; ++k) {
    osporcos[k].y  = aux;
    osporcos[k].x += n/2;
	aux = aux + n;
  }
}


if (0==G_state) {

  n = (instance_list(OPig)).length;

  for (k = 0; k < n; k++)
    (instance_list(OPig)[k]).sprite_index = SPig;
		
  bola = instance_list(OBall)[0];

  indexpig = irandom(9)-1;
  
  pig = osporcos[indexpig];

  boxbanner.meutexto  = "(0, ? )";
  boxbanner.meutexto2 = "(0,    )";
  boxbanner.tempo = -1;
  boxbanner.cx = 1;
  boxbanner.cy = room_height / 2;
  boxbanner.cy = 1;
  
  boxbanner.ok = -1;

 bola.visible = true;
 
 bola.x = 30;
 bola.y = pig.y + irandom (200) - 100;
 
 if (bola.y < 10) bola.y = 10;

 C = 3.5 * fps;
 A = (pig.x - bola.x)/C;
 B = (pig.y - (SPig.height/2) - bola.y)/C;
 
 
 G_speed = G_speed * 1.1;

 linha = linha - 30;
 n_fireball = n_fireball - 1;

 G_lucro = Math.floor(room_width / linha);

  if (n_fireball < 1) {
  
     callPHP(1);
     G_state = -1;

     if (GPontosFase > 0)
        room_goto_next();
	 else
	    room_goto (RoomTituloFase2);
		
	 return;
  }

  // crie super porco 
  if (flagsuperporco > 2) {
	    instance_create(10,10,OSuperPorco);
		flagsuperporco = 0;
  }
 
  flagminus = 0;
  G_state = 1;
}


if (1==G_state) {

  bola.x += A;
  bola.y += B;

  k = -1;

  if (bola.x >= pig.x) {
     G_state = 2;
	 boxbanner.ok = 0;
  }

  if (bola.x < linha) {

	if (keyboard_check_released (vk_0)){k=0;
	   osporcos[4].sprite_index = SPigShield;}
	if (keyboard_check_released (vk_1)){k=1;
	   osporcos[3 + 2*flagminus].sprite_index = SPigShield;}
	if (keyboard_check_released (vk_2)){k=2;
	   osporcos[2 + 4*flagminus].sprite_index = SPigShield;}
	if (keyboard_check_released (vk_3)){k=3;
	   osporcos[1 + 6*flagminus].sprite_index = SPigShield;}
	if (keyboard_check_released (vk_4)){k=4;
	   osporcos[8*flagminus].sprite_index = SPigShield;}
	if (keyboard_check_released (173) || keyboard_check_released (189)){
	   flagminus = 1;}

  } else
	k = -1;  // tarde demais para apertar tecla

  // jogador quer abandonar a fase
  if (keyboard_check_released (vk_p)){
       G_state = -1;
       room_goto_next();
	   return;
  }


  if (k > -1) {
	 G_state = 2;
	 G_tempo = tu_elapsed;
	 boxbanner.tempo = 3000;
 
	 if (flagminus) k = -k;
	 boxbanner.ok = (indexpig == (4-k));
     boxbanner.meutexto = "(0, " + k + " )";
	 
	 if (boxbanner.ok) {
	    flagsuperporco = flagsuperporco + 1;
	    G_placar += G_lucro;
		GPontosFase = GPontosFase + 1;
	 } else {
	    flagsuperporco = 0;
	    osporcos[indexpig].sprite_index = SPigMedo;
	}
   }
}

if (2==G_state) {

 G_tempo = G_tempo + tu_elapsed;

  bola.x += A;
  bola.y += B;

   if (bola.x >= pig.x) {
      if (boxbanner.ok) {
         G_state = 0;
         n = osporcos.length;
	     for (k = 0; k < n; k++) {
		   osporcos[k].sprite_index = SPig;
	     }
	  } else { // errou, crie anjo.
	     G_state = 3;
		 GEnergia = GEnergia - 0.5;
		 osporcos[indexpig].sprite_index = SPigAngel;
		 if (irandom(10)<2)
		    sound_play (SndPigSqueak);		 
		 A = osporcos[indexpig].y - 100;
		 B = osporcos[indexpig].x;
	  }
   }   
}

if (3==G_state) {
   osporcos[indexpig].x -= 2;
   osporcos[indexpig].y -= 2;
   
   if (osporcos[indexpig].y < A) {
      osporcos[indexpig].sprite_index = SPig;
      osporcos[indexpig].y = A+100;
      osporcos[indexpig].x = B;
	  G_state = 0;
   }
}
}
};
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = function() {
if (this.visible == 1) {
__handle_sprite__(this);
with(this) {
draw_set_color(0,0,200);
draw_set_linewidth(3);
draw_line(linha,5,linha,room_height-5);

draw_set_color(0,0,200);
draw_set_alpha(0.1);
draw_rectangle(linha,5,room_width-5,room_height-5,0);
draw_set_alpha(1.0);

drawCartesian (10,10,room_width-10, room_height-10,11,10,-10,5);

if (3!=G_state) {
  i = 0;
  ox = osporcos[0].x;
  pseudo_tempo = pseudo_tempo + 1/tu_elapsed;
  for (i = 1; i < osporcos.length; i = i + 1)
    osporcos[i].x = ox + 3 * Math.sin(pseudo_tempo + osporcos[i].y * 3 / room_height);
}

}
}
};
}; var OCtrlFase2 = new __OCtrlFase2();

function __OPlacar() {
__instance_init__(this, OPlacar, null, 1, -1, null, 0, 34);
this.on_creation = function() {
with(this) {
this.px= room_width - 100;
this.py= 10;
}
};
this.on_destroy = on_destroy_i;
this.on_step = on_step_i;
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = function() {
if (this.visible == 1) {
__handle_sprite__(this);
with(this) {
tu_draw_font = "20px arial"
draw_set_color(255,255,255);
draw_rectangle(px,py,px+80,py+35,0);
draw_set_color(50,0,50);
draw_text(px+3,py+5," "+(G_placar*10));

i = 0;

qx = px;
qy = py + 36
for(i = 0; i < GEnergia; i = i + 1) {
   draw_set_color(25*(10-i),25*i,0);
   draw_rectangle(qx,qy,qx+4,qy+12,1)
   qx = qx + 7;
}
}
}
};
}; var OPlacar = new __OPlacar();

function __OSuperPorco() {
__instance_init__(this, OSuperPorco, null, 1, 0, SuperPorco, 0, 39);
this.on_creation = function() {
with(this) {
this.a = 0;
this.b = 0;
G_placar = G_placar + 5;
sound_play(SndSuperPig);
}
};
this.on_destroy = on_destroy_i;
this.on_step = function() {
with(this) {
x += 2.5;
a = room_width / 2;
b = 7 * (x - a) / a;
y = 100 - (b * b);

if (mouse_check()) {

     sound_stop(SndSuperPig);
	 sound_play(SndMoedas);

     if ((mouse_x >= x) && (mouse_x <= x + SuperPorco.width) &&
	     (mouse_y >= y) && (mouse_y <= y + SuperPorco.height)) {
       G_placar = G_placar * 2;
	   GEnergia = 10;
       instance_destroy();
	   return;
   }
}

if (x > room_width)
   instance_destroy();
}
};
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = on_draw_i;
}; var OSuperPorco = new __OSuperPorco();

function __ODog() {
__instance_init__(this, ODog, null, 1, 0, SDog, 0, 41);
this.on_creation = function() {
with(this) {
this.targetx = x;
this.targety = y;
this.chegou = 0;
this.walking = true;
image_speed = 0.1;
}
};
this.on_destroy = on_destroy_i;
this.on_step = function() {
with(this) {

if (!walking)
   return;

if (x < targetx)
   ++x;
if (x > targetx)
   --x;
if (y < targety)
   ++y;
if (y > targety)
   --y;
   
   
chegou =  ((x==targetx) && (y==targety)) ;

//   --G_placar;
//   instance_destroy();
//}
}
};
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = on_draw_i;
}; var ODog = new __ODog();

function __OCtrlFase4() {
__instance_init__(this, OCtrlFase4, null, 1, 0, null, 0, 42);
this.on_creation = function() {
with(this) {
this.plantop   = room_height * 0.2;
this.planleft  = room_width  * 0.25;
this.planbot   = room_height * 0.8;
this.planright = room_width  * 0.75;
this.planmid   = this.planleft + (this.planright - this.planleft) / 2
this.idx = 0;
this.walltop = 0;
this.wallbot = 10;
this.gotas = 0;
this.porco = 0;
this.buttonA = 0;
this.buttonC = 0;
this.butsize = 0;
this.nloops = 10;
this.bolafogo = 0;

this.child = document.createElement('canvas');
this.childctx = child.getContext("2d");

}
};
this.on_destroy = on_destroy_i;
this.on_step = function() {
with(this) {
var k = 0;

if (-1==G_state) {

  GSala = 4;
  GFase = 4;
  GPontosFase = 0;

  GA = 0.5;
  GB = 0.0;
  GC = 0.0;
  G_state = 0;
  gotas = (instance_list(OWaterDrop));
  porco = (instance_list(OPigFogo))[0];
  buttonA = (instance_list(OButton))[0];
  buttonC = (instance_list(OButton))[1];
   
  bolafogo = (instance_list(OBall))[0];
  
  porco.sprite_index = SPigFogo;

  //criaForm();
  
  G_state = 0;
}

if (0==G_state) {

  for (k = 0; k < gotas.length; k++)
     gotas[k].visible = false;

  bolafogo.visible = true;
  
  porco.sprite_index = SPigFogo;
   
  walltop = plantop + 10 + irandom((planbot - plantop) - 30);
  
  callPHP(1);

  nloops = nloops - 1;
  
  if (nloops < 1) {
  
     G_state = -1;
	
	 if (GPontosFase > 4)
        room_goto_next();
	 else
	    room_goto (RoomTituloFase4);
		
	 return;
  }

  tempo = 10000;

  G_state = 1;
}


if (1==G_state) {

  if (mouse_pressed) {	 
     if ((mouse_x >= buttonA.x) && (mouse_x <= buttonA.x + SButtonsPM.width)) {
	    if ((mouse_y >= buttonA.y) && (mouse_y <= buttonA.y + SButtonsPM.height/2))
		   GA = GA + 0.1;
	    else if ((mouse_y >= buttonA.y + SButtonsPM.height/2) && (mouse_y <= buttonA.y + SButtonsPM.height))
		   GA = GA - 0.1;
	}	   
    else if ((mouse_x >= buttonC.x) && (mouse_x <= buttonC.x + SButtonsPM.width)) {
	    if ((mouse_y >= buttonC.y) && (mouse_y <= buttonC.y + SButtonsPM.height/2))
		   GC = GC + 0.1;
	    else if ((mouse_y >= buttonC.y + SButtonsPM.height/2) && (mouse_y <= buttonC.y + SButtonsPM.height))
		   GC = GC - 0.1;
	}	   
  }

  
  y = GPlany - (GPlanDeltay * ((((GA * 3) + GB) * 3) + GC));

  tempo -= tu_elapsed;

  if (tempo < 1) {
     G_state = 0;
	 G_energia = G_energia - 0.25;
	 sound_play(SndHorn);
	 return;
  }

  if (Math.abs(y-walltop) < 10) {
     GPontosFase = GPontosFase + 1;

     G_placar = G_placar + Math.floor (tempo / 400)

     G_state = 2;
	 tempo = 2500;
	 porco.sprite_index = SPigFogoApagado;
	 bolafogo.visible = false;
     for (k = 0; k < gotas.length; k++)
	    gotas[k].visible = true;
  }
}


if (2 == G_state) {
  for (k = 0; k < gotas.length; k++) {
     gotas[k].y += irandom(2);
	 if (gotas[k].y > porco.y) {
	    gotas[k].y -= 200;
		gotas[k].x = porco.x - 10 + irandom(20);
	 }	
  }
  tempo -= tu_elapsed;
  
  if (tempo < 1) {
     G_state = 0;
	 GEnergia = GEnergia - 0.5;
	 return;
  }
}

}
};
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = function() {
if (this.visible == 1) {
__handle_sprite__(this);
with(this) {
	drawCartesian (planleft,plantop,planright,planbot,6,6,-3,3);

//drawCartesian (room_width*0.2,room_height*0.2,room_width*0.8, room_height*0.8,6,6,-3,3);

idx = idx + 0.5;

if (idx > 5)
   idx = -3;


tu_draw_font="24px sans-serif";
draw_set_color(0,0,0);
s = " " + GA.toFixed(1) + "x";
childctx.font = "24px sans-serif";
var width = childctx.measureText(s).width;
draw_text(planleft + width, plantop/2-20, "2");

if (G_state > -1) {
   buttonA.x = planleft + width - 36;
   buttonA.y = (plantop - SButtonsPM.height) / 2;
}

if (GB >= 0)
   s = s + "  +" + GB;
else
   s = s + "  " + GB;

if (GC >= 0)
   s = s + "x +" + (GC).toFixed(1);
else
   s = s + "x " + (GC).toFixed(1);

draw_text(planleft, plantop/2 -10, s);

width = childctx.measureText(s).width;

if (G_state > -1) {
   buttonC.x = planleft + width - 36;
   buttonC.y = buttonA.y;
}


//draw_text(20, room_height - 60, ">>> tecle QWAS e jogue agua no porquinho!");
draw_text(20, room_height - 60, "Use os botoes jogue agua no porquinho!");

draw_set_alpha(1.0);
draw_set_color(0,50,0);
draw_rectangle(planright-10,plantop,planright+10,planbot,0);
draw_set_color(255,255,250);
draw_rectangle(planright-10,walltop-10,planright+10,walltop+10,0);

if (gotas[0].visible)
   drawWater(-3,5,idx);
else
   drawWater(-3,3,idx);

}
}
};
}; var OCtrlFase4 = new __OCtrlFase4();

function __OWaterDrop() {
__instance_init__(this, OWaterDrop, null, 0, 0, SDrop, 0, 45);
this.on_creation = on_creation_i;
this.on_destroy = on_destroy_i;
this.on_step = on_step_i;
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = on_draw_i;
}; var OWaterDrop = new __OWaterDrop();

function __OButton() {
__instance_init__(this, OButton, null, 1, 1, SButtonsPM, 0, 52);
this.on_creation = on_creation_i;
this.on_destroy = on_destroy_i;
this.on_step = on_step_i;
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = on_draw_i;
}; var OButton = new __OButton();

function __OWalkPig() {
__instance_init__(this, OWalkPig, null, 1, 0, SPigWalking, 1, 55);
this.on_creation = function() {
with(this) {
this.vy = 0.5;
this.ground = 300;
}
};
this.on_destroy = on_destroy_i;
this.on_step = function() {
with(this) {


if (keyboard_check_released (vk_up) || keyboard_check (vk_space)) {
   vy = -1.1;
   y = ground -1;
}

if (keyboard_check (vk_right)) {
   x = x + 5;
   
   if (x > room_width * 0.9)
      x= room_width * 0.9;
}

if (keyboard_check (vk_left)) {
   x = x - 5;
   
   if (x < room_width * 0.1)
      x= room_width * 0.1;
}



if (y < ground) {
   y = y + tu_elapsed * vy;
   vy = vy + tu_elapsed * 0.002;
}



if (y > ground) {
   y = ground;
   vy = 0;
}

}
};
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = on_draw_i;
}; var OWalkPig = new __OWalkPig();

function __OCoin() {
__instance_init__(this, OCoin, null, 1, 0, SCoinBrown, 1, 57);
this.on_creation = function() {
with(this) {
this.ground = 200;
this.vx = -0.09;
this.texto = "-2";
this.facevalue = 0;
}
};
this.on_destroy = on_destroy_i;
this.on_step = function() {
with(this) {

if (x > 0)
   x = x + vx * tu_elapsed;
else {
   visible = false;
   x = -1;
}
}
};
this.on_end_step = on_end_step_i;
this.on_collision = function() {
with(this) {
this.other = this.place_meeting(this.x, this.y, OWalkPig);
if(this.other != null) {

// marque acertos de 100 em 100
if (GA * facevalue > 0) {
   GPontosFase = GPontosFase + 100;
   G_placar = G_placar + 1;
}

// marque erros de 1 em 1
if (GA * facevalue < 0) {
   GPontosFase = GPontosFase + 1;
   GEnergia = GEnergia - 0.25;
   sound_play (SndHorn);
}


if (0==facevalue) {
   if (sprite_index == SPan) {
      GEnergia = GEnergia - 0.5;
      sound_play (SndPigSqueak2);
   }      
   if (sprite_index == SApple) {
      G_placar = G_placar + 4;
      sound_play(SndMoedas);
      GEnergia = GEnergia + 1;
	  if (GEnergia > 10) GEnergia = 10;
   } 
   if (sprite_index == SEspiga)
      G_placar = G_placar + 2;
      GEnergia = GEnergia + 0.25;
	  if (GEnergia > 10) GEnergia = 10;
}   
     
visible = false;
x = -1;
facevalue = 0;
vx = -0.9;
}
}
};
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = function() {
if (this.visible == 1) {
__handle_sprite__(this);
with(this) {

if (x < 0)
   return;

draw_sprite(this.sprite_index,0,x,y);

//if ((SEspiga==sprite_index) || (SApple== sprite_index) || (SPan==sprite_index))
if (0==facevalue)
   return;

tu_draw_font="32px sans-serif";
draw_set_color (255, 255, 255);
draw_text (x+5, y + SCoinBrown.height/2 - 10, texto);


}
}
};
}; var OCoin = new __OCoin();

function __OCtrlFase5() {
__instance_init__(this, OCtrlFase5, null, 1, 0, null, 1, 61);
this.on_creation = function() {
with(this) {
this.plantop   = room_height * 0.1;
this.planleft  = room_width  * 0.1;
this.planbot   = room_height * 0.5;
this.planright = room_width  * 0.5;
this.planmid   = this.planleft + (this.planright - this.planleft) / 2;
this.nciclos = 10;
this.nmoedas = 1;
this.tempo = 4000;
this.flagsuperporco = 0;

}
};
this.on_destroy = on_destroy_i;
this.on_step = function() {
with(this) {

if (-1 == G_state) {

   GSala = 5;
   GFase = 5;
   GPontosFase = 0;

   chao = room_height * 0.8;

   instance_list(OWalkPig)[0].ground = chao;
   
   moedas = instance_list(OCoin);
   
   nmoedas = moedas.length;
   
   i = 1;
   for (i = 0; i < nmoedas; i = i + 1)
      moedas[i].y = chao;// - SCoinBrown.height * 0.25;
	
   GA = 1;
   GB = 0;
   GC = -1;

   sound_stop_all ();	
   sound_play(Music2);
   sound_loop(Music2);
   sound_volume(Music2,0.5);
 
   tempo = 10000;
   nciclos = 1;
   G_state = 0;
}

if (0 == G_state) {

   tempo = tempo - tu_elapsed;
   if (tempo < 0) {
      G_state = 1;
	  return;
   }

   i = 1;
   a = 0;
   b = -1;
   for (i = 0; i < nmoedas; i = i + 1) {
      if (moedas[i].visible) {
	     if (moedas[i].x > a)
		    a = moedas[i].x;
      } else
	     b = i;
   }
   
   // nunca deveria acontecer,
   //  mas os eventos assincronos talvez possam levar a essa condição.
   if (b == nmoedas) b = -1;
   
   if ( (b > -1) && 
        (a < (room_width - 2 * SCoinBrown.width)) && 
		(irandom(100) < 15)
	   ) {
   
   
      moedas[b].visible = true;
	  moedas[b].x = room_width;
	  
	  a = irandom (9);
	  if (irandom(100) < 50)
	     a = -a;
		 
	  moedas[b].facevalue = a;		 
	  moedas[b].texto = a.toString();
      moedas[b].vx = -0.09;  // velocidade normal
	  moedas[b].y = chao;
   
      a = irandom (nciclos);
	  
	  if (a == 1)  moedas[b].sprite_index = SCoinBlue;
	  if (a == 2)  moedas[b].sprite_index = SCoinBrown;
	  if (a == 3) {
	     moedas[b].sprite_index = SEspiga;
		 moedas[b].facevalue = 0;
		 moedas[b].vx = -0.1;
	  }
	  if ((a == 4) || (a == 10)) {
	     moedas[b].sprite_index = SCoinRed;
		 moedas[b].vx = -0.13;
	  } 
	  if ((a == 5) || (a == 8)) {
	     moedas[b].sprite_index = SPan;
		 moedas[b].facevalue = 0;
		 moedas[b].vx = -0.08;
	  }
	  if (a == 6)  moedas[b].sprite_index = SCoinGreen;
	  if ((a == 7) || (a == 9)) {
	     moedas[b].sprite_index = SApple;
		 moedas[b].vx = -0.13;
		 moedas[b].y = chao - SApple.height;
		 moedas[b].facevalue = 0;
		 GEnergia = GEnergia + 0.5;
		 if (GEnergia > 10) GEnergia = 10;
	  }
   }
}

if (1 == G_state) {

   if (irandom(100) < 50)
      GA = -1;
   else
      GA = 1;
   
   tempo = 10000;
   nciclos = nciclos + 1;

   if (nciclos > 10) {
      sound_stop_all ();	
      callPHP(1);
      G_state = -1;
      room_goto_next();
	  return;
   }
   G_state = 0;
}
}
};
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = function() {
if (this.visible == 1) {
__handle_sprite__(this);
with(this) {
drawCartesian (planleft,plantop,planright,planbot,8,8,-4,4);
//drawCartesian (planleft,plantop,planright,planbot,10,10,-5,5);
drawParabola(-3,3);
}
}
};
}; var OCtrlFase5 = new __OCtrlFase5();

function __OSausage() {
__instance_init__(this, OSausage, null, 1, 0, SSausage, 0, 68);
this.on_creation = function() {
with(this) {
this.tempo = 0;
this.dog = 0;
}
};
this.on_destroy = on_destroy_i;
this.on_step = function() {
with(this) {
tempo = tempo - tu_elapsed;

if (tempo < 0) {
   dog.walking = true;
   visible = false;
}
}
};
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = on_draw_i;
}; var OSausage = new __OSausage();

function __OChiqueiro() {
__instance_init__(this, OChiqueiro, null, 1, 0, SChiqueiro, 0, 69);
this.on_creation = on_creation_i;
this.on_destroy = on_destroy_i;
this.on_step = on_step_i;
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = on_draw_i;
}; var OChiqueiro = new __OChiqueiro();

function __OPigFogo() {
__instance_init__(this, OPigFogo, null, 1, 0, SPigFogo, 0, 74);
this.on_creation = on_creation_i;
this.on_destroy = on_destroy_i;
this.on_step = on_step_i;
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = on_draw_i;
}; var OPigFogo = new __OPigFogo();

function __OEspereAcabou() {
__instance_init__(this, OEspereAcabou, null, 1, 0, null, 1, 76);
this.on_creation = function() {
with(this) {
this.tempo = 3000;
}
};
this.on_destroy = on_destroy_i;
this.on_step = function() {
with(this) {
tempo -= tu_elapsed;

if (tempo < 1) {
   
   room_goto_next();
   return;
}

}
};
this.on_end_step = on_end_step_i;
this.on_collision = on_collision_i;
this.on_roomstart = on_roomstart_i;
this.on_roomend = on_roomend_i;
this.on_animationend = on_animationend_i;
this.on_draw = on_draw_i;
}; var OEspereAcabou = new __OEspereAcabou();



/***********************************************************************
 * SCENES
 ***********************************************************************/
function __RoomTituloFase1() { 
this.tiles = [
];
this.objects = [
[{o:OEspere, x:100, y:220}],
[{o:OChiqueiro, x:400, y:240}],
[{o:OBall, x:380, y:180}]];
this.start = function() {
__room_start__(this, RoomTituloFase1, 800, 600, 30, 0, 0, 0, BackTituloFase1.image, 0, 0, 1, 800, 600, null, 50, 50);
};
}
var RoomTituloFase1 = new __RoomTituloFase1();
tu_scenes.push(RoomTituloFase1);
function __RoomFase1() { 
this.tiles = [
];
this.objects = [
[{o:OBall, x:100, y:20}],
[{o:OPig, x:150, y:510}],
[{o:OPig, x:217, y:510}],
[{o:OPig, x:284, y:510}],
[{o:OPig, x:351, y:510}],
[{o:OPig, x:418, y:510}],
[{o:OPig, x:485, y:510}],
[{o:OPig, x:557, y:510}],
[{o:OPig, x:624, y:510}],
[{o:OPig, x:691, y:510}],
[{o:OPig, x:758, y:510}],
[{o:OPlacar, x:580, y:40}],
[{o:OCtrlFase1, x:540, y:40}],
[{o:OCoordenadas, x:620, y:40}]];
this.start = function() {
__room_start__(this, RoomFase1, 800, 600, 60, 0, 0, 0, BackFarm.image, 0, 0, 0, 800, 600, null, 50, 50);
};
}
var RoomFase1 = new __RoomFase1();
tu_scenes.push(RoomFase1);
function __RoomTituloFase2() { 
this.tiles = [
];
this.objects = [
[{o:OEspere, x:80, y:40}]];
this.start = function() {
__room_start__(this, RoomTituloFase2, 800, 600, 30, 0, 0, 0, BackTituloFase2.image, 0, 0, 0, 800, 600, null, 50, 50);
};
}
var RoomTituloFase2 = new __RoomTituloFase2();
tu_scenes.push(RoomTituloFase2);
function __RoomFase2() { 
this.tiles = [
];
this.objects = [
[{o:OCtrlFase2, x:20, y:20}],
[{o:OPig, x:640, y:5}],
[{o:OPig, x:640, y:75}],
[{o:OPig, x:640, y:145}],
[{o:OPig, x:640, y:215}],
[{o:OPig, x:640, y:285}],
[{o:OPig, x:640, y:360}],
[{o:OPig, x:640, y:430}],
[{o:OPig, x:640, y:495}],
[{o:OPig, x:640, y:570}],
[{o:OCoordenadas, x:45, y:20}],
[{o:OBall, x:40, y:260}],
[{o:OPlacar, x:80, y:20}]];
this.start = function() {
__room_start__(this, RoomFase2, 800, 600, 60, 0, 0, 0, BackFarm2.image, 0, 0, 0, 800, 600, null, 50, 50);
};
}
var RoomFase2 = new __RoomFase2();
tu_scenes.push(RoomFase2);
function __RoomTituloFase3() { 
this.tiles = [
];
this.objects = [
[{o:OEspere, x:60, y:40}]];
this.start = function() {
__room_start__(this, RoomTituloFase3, 800, 600, 30, 0, 0, 0, BackTituloFase3.image, 0, 0, 1, 800, 600, null, 50, 50);
};
}
var RoomTituloFase3 = new __RoomTituloFase3();
tu_scenes.push(RoomTituloFase3);
function __RoomTituloFase3B() { 
this.tiles = [
];
this.objects = [
[{o:ODog, x:280, y:180}],
[{o:OEspere, x:40, y:40}]];
this.start = function() {
__room_start__(this, RoomTituloFase3B, 800, 600, 30, 0, 0, 0, BackTituloFase3b.image, 0, 0, 0, 800, 600, null, 50, 50);
};
}
var RoomTituloFase3B = new __RoomTituloFase3B();
tu_scenes.push(RoomTituloFase3B);
function __RoomFase3() { 
this.tiles = [
];
this.objects = [
[{o:OCtrlFase3, x:40, y:20}],
[{o:OPlacar, x:80, y:20}],
[{o:OCoordenadas, x:120, y:20}]];
this.start = function() {
__room_start__(this, RoomFase3, 800, 600, 40, 255, 255, 255, BackFarm3.image, 0, 0, 0, 800, 600, null, 50, 50);
};
}
var RoomFase3 = new __RoomFase3();
tu_scenes.push(RoomFase3);
function __RoomTituloFase4() { 
this.tiles = [
];
this.objects = [
[{o:OEspere, x:40, y:40}]];
this.start = function() {
__room_start__(this, RoomTituloFase4, 800, 600, 30, 0, 0, 0, BackTituloFase4.image, 0, 0, 0, 800, 600, null, 50, 50);
};
}
var RoomTituloFase4 = new __RoomTituloFase4();
tu_scenes.push(RoomTituloFase4);
function __RoomFase4() { 
this.tiles = [
];
this.objects = [
[{o:OCtrlFase4, x:20, y:20}],
[{o:OBall, x:700, y:560}],
[{o:OWaterDrop, x:700, y:440}],
[{o:OWaterDrop, x:720, y:400}],
[{o:OWaterDrop, x:720, y:360}],
[{o:OWaterDrop, x:700, y:340}],
[{o:OWaterDrop, x:704, y:286}],
[{o:OButton, x:120, y:20}],
[{o:OButton, x:200, y:20}],
[{o:OPlacar, x:60, y:20}],
[{o:OPigFogo, x:680, y:480}]];
this.start = function() {
__room_start__(this, RoomFase4, 800, 600, 30, 255, 255, 255, BackFarm4.image, 0, 0, 0, 800, 600, null, 50, 50);
};
}
var RoomFase4 = new __RoomFase4();
tu_scenes.push(RoomFase4);
function __RoomTituloFase5() { 
this.tiles = [
];
this.objects = [
[{o:OEspere, x:20, y:20}]];
this.start = function() {
__room_start__(this, RoomTituloFase5, 640, 480, 30, 0, 0, 0, BackTituloFase5.image, 0, 0, 0, 640, 480, null, 50, 50);
};
}
var RoomTituloFase5 = new __RoomTituloFase5();
tu_scenes.push(RoomTituloFase5);
function __RoomFase5() { 
this.tiles = [
];
this.objects = [
[{o:OWalkPig, x:220, y:260}],
[{o:OCoin, x:740, y:260}],
[{o:OPlacar, x:20, y:20}],
[{o:OCtrlFase5, x:60, y:20}],
[{o:OCoin, x:560, y:220}],
[{o:OCoin, x:0, y:200}]];
this.start = function() {
__room_start__(this, RoomFase5, 800, 600, 30, 228, 232, 164, BackFarm5.image, 0, 0, 0, 800, 600, null, 50, 50);
};
}
var RoomFase5 = new __RoomFase5();
tu_scenes.push(RoomFase5);
function __RoomAcabou() { 
this.tiles = [
];
this.objects = [
[{o:OEspereAcabou, x:20, y:20}]];
this.start = function() {
__room_start__(this, RoomAcabou, 640, 480, 30, 0, 0, 0, BackFim.image, 0, 0, 0, 640, 480, null, 50, 50);
};
}
var RoomAcabou = new __RoomAcabou();
tu_scenes.push(RoomAcabou);
function __RoomFIM() { 
this.tiles = [
];
this.objects = [
[{o:OEspere, x:20, y:20}]];
this.start = function() {
__room_start__(this, RoomFIM, 800, 600, 30, 0, 0, 0, BackCreditos.image, 0, 0, 0, 800, 600, null, 50, 50);
};
}
var RoomFIM = new __RoomFIM();
tu_scenes.push(RoomFIM);
tu_room_to_go = RoomTituloFase1;


/***********************************************************************
 * CUSTOM GLOBAL VARIABLES
 ***********************************************************************/
var GPlayerName="noname";
var G_state=-1;
var G_tempo=0;
var G_speed=1.9;
var GA = -1;
var GB = 0;
var GC = 3;
var G_placar = 0;
var G_lucro = 1;
var GPlanDeltax = 0;
var GPlanDeltay = 0;
var GPlanx = 0;
var GPlany = 0;
var GMinX = 0;
var GEnergia = 10;
var GSala = 1;
var GFase = 1;
var GPontosFase = 0;

/***********************************************************************
 * CUSTOM GLOBAL FUNCTIONS
 ***********************************************************************/

function callPHP(tipo) { 
var httpc = new XMLHttpRequest();

if (1==tipo)
   aurl = "http://www.linguafrancesa.com/math/vai.php?par1=" + GPlayerName
           + "&par2=1"
           + "&par3="  + (GFase.toString())
           + "," + (GPontosFase.toString());

//if (1==tipo)
//   aurl = "http://localhost/vai.php?par1=" + GPlayerName
//           + "&par2=1" + 
//           + "&par3=" + (GFase.toString())
//           + "&par4=" + (GPontosFase.toString());

if (2==tipo)
   aurl = "http://www.linguafrancesa.com/math/vai.php?par1=" + GPlayerName
           + "&par2=2"
           + "&par3=" 
           + navigator.appCodeName +"," + navigator.platform;


//httpc.onreadystatechange = function() {
   //if (this.readyState == 4 && this.status == 200) {
   //if (this.status == 200) {
//      this.send(aurl);
//	  console.log(aurl);
   //}
//} 	

httpc.open("POST", aurl, true);
httpc.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
httpc.setRequestHeader("Content-Length", aurl.length);
httpc.send(aurl);

}
function drawCartesian(left,top,right,bottom,nx,ny,ix,iy) { 
iy = -iy;
GPlanDeltax = (right-left) / (nx);
GPlanDeltay = (bottom-top) / (ny);

GPlanx = left  - ((ix) * GPlanDeltax);
GPlany = top   - ((iy) * GPlanDeltay);

GMinX = ix;

tu_draw_font="bold 24px sans-serif"
draw_set_linewidth(1);

a = left;
while (a <= right) {
   draw_set_color(180,180,180);
   draw_line (a, top, a, bottom);
   draw_set_color(0,0,0);
   draw_text (a, GPlany+2, " "+ix);
   a = a + GPlanDeltax;
   ++ix;
}   
a = top;
while (a <= bottom) {
   draw_set_color(180,180,180);
   draw_line (left, a, right, a);
   draw_set_color(0,0,0);
   draw_text (GPlanx+5, a, " "+(-iy));
   a = a + GPlanDeltay;
   ++iy;
} 

draw_set_linewidth(3);
draw_set_color(20,20,60);
draw_line (left, GPlany, right, GPlany);
draw_line (GPlanx, top, GPlanx, bottom);

GPlanx = left;
}
function drawParabola(x1,x2) { 
var x = GMinX;
var y = 0;
var px = GPlanx;
var oldx = -100;
var oldy = -1;

draw_set_color(60,60,250);
draw_set_linewidth(3);


while (x < x1) {
   x = x + 1;
   px = px + GPlanDeltax;
}

while (x <= x2) {

   y = GPlany - (GPlanDeltay * (((GA * x) + GB) * x) + GC);
   
   draw_circle(px, y, 6);
   
   if (oldx > -100)
      draw_line(oldx,oldy,px,y);
	  
   oldx = px;
   oldy = y;
      
   x = x + 1;
   px = px + GPlanDeltax;
}

/*
iy = -iy;
deltax = (right-left) / (nx);

nx = left + 5 - ((ix) * deltax);
ny = top  + 2 - ((iy) * deltay);

draw_set_linewidth(1);

x = left;
y = 0;
while (a <= right) {
   y = ((GA * x) + GB) * x) + GC;
   x = x + deltax;
}   
*/
}
function drawWater(x1,x2,i) { 
var x = x1;
var y = 0;
var px = GPlanx;
var oldx = -100;
var oldy = -1;

draw_set_color(10,10,250);
draw_set_linewidth(6);

while (x <= x2) {

   y = GPlany - (GPlanDeltay * ((((GA * x) + GB) * x) + GC));
   
   if (i == x)
      draw_circle(px, y, 9);
   else	  
      draw_circle(px, y, 6);
   
   if (oldx > -100)
      draw_line(oldx,oldy,px,y);
	  
   oldx = px;
   oldy = y;
  
   x = x + 0.5;
   px = px + GPlanDeltax/2;
}
}
function leiaCookie() { 
 // troque nome pelo nome do cookie!
 var re = new RegExp("nome=([^;]+)"); 
 var valor = re.exec(document.cookie); 
 
 if (valor != null)
     GPlayerName = valor[1];//decodeURI(valor[1]);
	
 return GPlayerName;
}
function criaForm() { 
mypara=document.getElementById("paraID");
myform=document.createElement("form");

labX=document.createTextNode(" X =");
mytextX = document.createElement("input");
mytextX.type = "text";

labY=document.createTextNode("   Y =");
mytextY = document.createElement("input");
mytextY.type = "text";

myform.appendChild(labX);
myform.appendChild(mytextX);
myform.appendChild(labY);
myform.appendChild(mytextY);
mypara.appendChild(myform);
}
function destroiForm() { 
myPara=document.getElementById("paraID");
myform=document.getElementById("formID");
myPara.removeChild(myform);
}


tu_gameloop = tu_loop;
tu_loop();
